/*
 * Created on 26/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class AdapterDeclaration extends CommonInformation {

	private String Type;
	// Use the Name of Parameter as Key
	private Hashtable<String, Parameter> parameters = null;

	public AdapterDeclaration(String Name, String Type, String Comment,
			Hashtable<String, Parameter> parameters) {
		super(Name, Comment);
		this.Type = Type;
		this.parameters = parameters;
	}

	public String toString() {
		return "AdapterDeclaration";
	}

	public Element toXML() {
		Element adapterDeclarationElement = new Element("AdapterDeclaration");

		adapterDeclarationElement.setAttribute("Name", Name);
		adapterDeclarationElement.setAttribute("Type", Type);
		if(Comment != null)
			adapterDeclarationElement.setAttribute("Comment", Comment);

		if(parameters != null) {
			for(Parameter parameter : parameters.values()) {
				adapterDeclarationElement.addContent(parameter.toXML());
			}
		}

		// Object[] parameterObjs = parameters.values().toArray();
		// for(int j = parameterObjs.length - 1; j > -1; j--) {
		// adapterDeclarationElement.addContent(((Parameter) parameterObjs[j])
		// .toXML());
		// }

		return adapterDeclarationElement;
	}

	public void print() {
		System.out.println("Name: " + Name);
		System.out.println("Type: " + Type);
		System.out.println("Comment: " + Comment);
		if(parameters != null) {
			for(Parameter parameter : parameters.values()) {
				parameter.print();
			}
		}
	}

	public Hashtable<String, Parameter> getParameters() {
		return parameters;
	}

	public void setParameters(Hashtable<String, Parameter> parameters) {
		this.parameters = parameters;
	}

	public String getType() {
		return Type;
	}

	public void setType(String type) {
		Type = type;
	}

}
