/*
 * Created on 26/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class BasicFB {
	private InternalVars internalVars = null;
	private ECC ecc = null;
	private Hashtable<String, Algorithm> algorithms = null;

	public BasicFB(InternalVars internalVars, ECC ecc,
			Hashtable<String, Algorithm> algorithms) {
		this.internalVars = internalVars;
		this.ecc = ecc;
		this.algorithms = algorithms;
	}

	public String toString() {
		return "BasicFB";
	}

	public Element toXML() {
		Element basicFBElement = new Element("BasicFB");

		if(internalVars != null)
			basicFBElement.addContent(internalVars.toXML());
		if(ecc != null)
			basicFBElement.addContent(ecc.toXML());

		if(algorithms != null) {
			for(Algorithm algorithm : algorithms.values()) {
				basicFBElement.addContent(algorithm.toXML());
			}
		}
		return basicFBElement;
	}

	public void print() {
		if(internalVars != null) {
			internalVars.print();
		}
		else {
			System.out.println("internalVars is empty");
		}

		if(ecc != null) {
			ecc.print();
		}
		else {
			System.out.println("ecc is empty");
		}

		if(algorithms != null) {
			for(Algorithm algorithm : algorithms.values()) {
				algorithm.print();
			}
		}
	}

	public Hashtable<String, Algorithm> getAlgorithms() {
		return algorithms;
	}

	public void setAlgorithms(Hashtable<String, Algorithm> algorithms) {
		this.algorithms = algorithms;
	}

	public ECC getEcc() {
		return ecc;
	}

	public void setEcc(ECC ecc) {
		this.ecc = ecc;
	}

	public InternalVars getInternalVars() {
		return internalVars;
	}

	public void setInternalVars(InternalVars internalVars) {
		this.internalVars = internalVars;
	}
}
