/*
 * Created on 29/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class CompilerInfo {

	private String header = null;
	private String classdef = null;

	// Use Integer from 0 as Key
	private Hashtable<Integer, FBCompiler> fbCompilers = null;

	public CompilerInfo(String header, String classdef,
			Hashtable<Integer, FBCompiler> fbCompilers) {
		this.header = header;
		this.classdef = classdef;
		this.fbCompilers = fbCompilers;

	}

	public String toString() {
		return "CompilerInfo";
	}

	public Element toXML() {
		Element compilerInfoElement = new Element("CompilerInfo");

		if(header != null)
			compilerInfoElement.setAttribute("header", header);
		if(classdef != null)
			compilerInfoElement.setAttribute("classdef", classdef);

		if(fbCompilers != null) {
			for(FBCompiler fbCompiler : fbCompilers.values()) {
				compilerInfoElement.addContent(fbCompiler.toXML());
			}
		}

		return compilerInfoElement;
	}

	public void print() {
		System.out.println("header: " + header);
		System.out.println("classdef: " + classdef);
		if(fbCompilers != null) {
			for(FBCompiler fbCompiler : fbCompilers.values()) {
				fbCompiler.print();
			}
		}
	}

	public String getClassdef() {
		return classdef;
	}

	public void setClassdef(String classdef) {
		this.classdef = classdef;
	}

	public Hashtable<Integer, FBCompiler> getFbCompilers() {
		return fbCompilers;
	}

	public void setFbCompilers(Hashtable<Integer, FBCompiler> fbCompilers) {
		this.fbCompilers = fbCompilers;
	}

	public String getHeader() {
		return header;
	}

	public void setHeader(String header) {
		this.header = header;
	}

}
