/*
 * Created on 6/09/2006
 */

package fbtypes;

import org.jdom.Element;

public class Connection {

	private String Source;
	private String Destination;
	private String Comment = null;

	private String dx1 = null, dx2 = null, dy = null;

	public Connection(String Source, String Destination, String Comment,
			String dx1, String dx2, String dy) {
		this.Source = Source;
		this.Destination = Destination;
		if(Comment != null) {
			this.Comment = Comment;
		}
		if(dx1 != null) {
			this.dx1 = dx1;
		}
		if(dx2 != null) {
			this.dx2 = dx2;
		}
		if(dy != null) {
			this.dy = dy;
		}
	}

	public String toString() {
		return "Connection";
	}

	public Element toXML() {
		Element connectionElement = new Element("Connection");

		connectionElement.setAttribute("Source", Source);
		connectionElement.setAttribute("Destination", Destination);
		if(Comment != null)
			connectionElement.setAttribute("Comment", Comment);
		if(dx1 != null)
			connectionElement.setAttribute("dx1", dx1);
		if(dx2 != null)
			connectionElement.setAttribute("dx2", dx2);
		if(dy != null)
			connectionElement.setAttribute("dy", dy);

		return connectionElement;
	}

	public void print() {
		System.out.println("Source: " + Source);
		System.out.println("Destination: " + Destination);
		System.out.println("Comment: " + Comment);
		System.out.println("dx1: " + dx1);
		System.out.println("dx2: " + dx2);
		System.out.println("dy: " + dy);
	}

	public String getComment() {
		return Comment;
	}

	public void setComment(String comment) {
		Comment = comment;
	}

	public String getDestination() {
		return Destination;
	}

	public void setDestination(String destination) {
		Destination = destination;
	}

	public String getDx1() {
		return dx1;
	}

	public void setDx1(String dx1) {
		this.dx1 = dx1;
	}

	public String getDx2() {
		return dx2;
	}

	public void setDx2(String dx2) {
		this.dx2 = dx2;
	}

	public String getDy() {
		return dy;
	}

	public void setDy(String dy) {
		this.dy = dy;
	}

	public String getSource() {
		return Source;
	}

	public void setSource(String source) {
		Source = source;
	}

}
