/*
 * Created on 26/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class ECC {

	// Use Name as Key for ecStates
	private Hashtable<String, ECState> ecStates;
	// Use Source+Destination+Condition as Key for ecTransitions
	private Hashtable<String, ECTransition> ecTransitions;

	public ECC(Hashtable<String, ECState> ecStates,
			Hashtable<String, ECTransition> ecTransitions) {
		if(ecStates.isEmpty()) {
			System.err.println("ecStates in ECC is empty");
			System.exit(0);
		}
		else {
			this.ecStates = ecStates;
		}
		if(ecTransitions.isEmpty()) {
			System.err.println("ecTransitions in ECC is empty");
			System.exit(0);
		}
		else {
			this.ecTransitions = ecTransitions;
		}
	}

	public String toString() {
		return "ECC";
	}

	public Element toXML() {
		Element eccElement = new Element("ECC");

		for(ECState ecState : ecStates.values()) {
			eccElement.addContent(ecState.toXML());
		}

		for(ECTransition ecTransition : ecTransitions.values()) {
			eccElement.addContent(ecTransition.toXML());
		}

		// Object[] ecStateObjs = ecStates.values().toArray();
		// for(int j = ecStateObjs.length - 1; j > -1; j--) {
		// eccElement.addContent(((ECState) ecStateObjs[j]).toXML());
		// }
		//
		// Object[] ecTransitionObjs = ecTransitions.values().toArray();
		// for(int j = ecTransitionObjs.length - 1; j > -1; j--) {
		// eccElement.addContent(((ECTransition) ecTransitionObjs[j]).toXML());
		// }

		return eccElement;
	}

	public void print() {
		for(ECState ecState : ecStates.values()) {
			ecState.print();
		}

		for(ECTransition ecTransition : ecTransitions.values()) {
			ecTransition.print();
		}
	}

	public Hashtable<String, ECState> getEcStates() {
		return ecStates;
	}

	public void setEcStates(Hashtable<String, ECState> ecStates) {
		this.ecStates = ecStates;
	}

	public Hashtable<String, ECTransition> getEcTransitions() {
		return ecTransitions;
	}

	public void setEcTransitions(Hashtable<String, ECTransition> ecTransitions) {
		this.ecTransitions = ecTransitions;
	}
}
