/*
 * Created on 26/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class ECState extends CommonInformation {

	// Use Integer from 0 as Key
	private Hashtable<Integer, ECAction> ecActions = null;
	private String x = null;
	private String y = null;

	public ECState(String Name, String Comment, String x, String y,
			Hashtable<Integer, ECAction> ecActions) {
		super(Name, Comment);
		this.x = x;
		this.y = y;
		this.ecActions = ecActions;
	}

	public String toString() {
		return "ECState";
	}

	public Element toXML() {
		Element ecStateElement = new Element("ECState");

		ecStateElement.setAttribute("Name", Name);
		if(Comment != null)
			ecStateElement.setAttribute("Comment", Comment);
		if(x != null)
			ecStateElement.setAttribute("x", x);
		if(y != null)
			ecStateElement.setAttribute("y", y);

		if(ecActions != null) {
			for(ECAction ecAction : ecActions.values()) {
				ecStateElement.addContent(ecAction.toXML());
			}
		}

		// Object[] ecActionObjs = ecActions.values().toArray();
		// for(int j = ecActionObjs.length - 1; j > -1; j--) {
		// ecStateElement.addContent(((ECAction) ecActionObjs[j]).toXML());
		// }

		return ecStateElement;
	}

	public void print() {
		super.print();
		System.out.println("x: " + x);
		System.out.println("y: " + y);
		if(ecActions != null) {
			for(ECAction ecAction : ecActions.values()) {
				ecAction.print();
			}
		}
	}

	public Hashtable<Integer, ECAction> getEcActions() {
		return ecActions;
	}

	public void setEcActions(Hashtable<Integer, ECAction> ecActions) {
		this.ecActions = ecActions;
	}

	public String getX() {
		return x;
	}

	public void setX(String x) {
		this.x = x;
	}

	public String getY() {
		return y;
	}

	public void setY(String y) {
		this.y = y;
	}

}
