/*
 * Created on 26/01/2007
 */

package fbtypes;

import org.jdom.Element;

public class ECTransition {
	private String Source;
	private String Destination;
	private String Condition;
	private String Comment = null;
	private String x = null;
	private String y = null;

	public ECTransition(String Source, String Destination, String Condition,
			String Comment, String x, String y) {
		this.Source = Source;
		this.Destination = Destination;
		this.Condition = Condition;
		if(Comment != null) {
			this.Comment = Comment;
		}
		if(x != null) {
			this.x = x;
		}
		if(y != null) {
			this.y = y;
		}
	}

	public String toString() {
		return "ECTransition";
	}

	public Element toXML() {
		Element ecTransitionElement = new Element("ECTransition");

		ecTransitionElement.setAttribute("Source", Source);
		ecTransitionElement.setAttribute("Destination", Destination);
		ecTransitionElement.setAttribute("Condition", Condition);
		if(Comment != null)
			ecTransitionElement.setAttribute("Comment", Comment);
		if(x != null)
			ecTransitionElement.setAttribute("x", x);
		if(y != null)
			ecTransitionElement.setAttribute("y", y);

		return ecTransitionElement;
	}

	public void print() {
		System.out.println("Source: " + Source);
		System.out.println("Destination: " + Destination);
		System.out.println("Condition: " + Condition);
		System.out.println("Comment: " + Comment);
		System.out.println("x: " + x);
		System.out.println("y: " + y);
	}

	public String getComment() {
		return Comment;
	}

	public void setComment(String comment) {
		Comment = comment;
	}

	public String getCondition() {
		return Condition;
	}

	public void setCondition(String condition) {
		Condition = condition;
	}

	public String getDestination() {
		return Destination;
	}

	public void setDestination(String destination) {
		Destination = destination;
	}

	public String getSource() {
		return Source;
	}

	public void setSource(String source) {
		Source = source;
	}

	public String getX() {
		return x;
	}

	public void setX(String x) {
		this.x = x;
	}

	public String getY() {
		return y;
	}

	public void setY(String y) {
		this.y = y;
	}

}
