/*
 * Created on 6/09/2006
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class FB extends CommonInformation {

	private String Type;
	private String x = null;
	private String y = null;
	// Use Name of Parameter as Key
	private Hashtable<String, Parameter> parameters = null;

	public FB(String Name, String Type, String Comment, String x, String y,
			Hashtable<String, Parameter> parameters) {
		super(Name, Comment);
		this.Type = Type;
		this.x = x;
		this.y = y;
		this.parameters = parameters;
	}

	public String toString() {
		return "FB";
	}

	public Element toXML() {
		Element fbElement = new Element("FB");

		fbElement.setAttribute("Name", Name);
		fbElement.setAttribute("Type", Type);
		if(Comment != null)
			fbElement.setAttribute("Comment", Comment);
		if(x != null)
			fbElement.setAttribute("x", x);
		if(y != null)
			fbElement.setAttribute("y", y);
		if(parameters != null) {
			for(Parameter parameter : parameters.values()) {
				fbElement.addContent(parameter.toXML());
			}
		}

		// Object[] parameterObjs = parameters.values().toArray();
		// for(int j = parameterObjs.length - 1; j > -1; j--) {
		// fbElement.addContent(((Parameter) parameterObjs[j]).toXML());
		// }

		return fbElement;
	}

	public void print() {
		super.print();
		System.out.println("Type: " + Type);
		System.out.println("x: " + x);
		System.out.println("y: " + y);
		if(parameters != null) {
			for(Parameter parameter : parameters.values()) {
				parameter.print();
			}
		}
	}

	public void setComment(String comment) {
		Comment = comment;
	}

	public String getType() {
		return Type;
	}

	public void setType(String type) {
		Type = type;
	}

	public Hashtable<String, Parameter> getParameters() {
		return parameters;
	}

	public void setParameters(Hashtable<String, Parameter> parameters) {
		this.parameters = parameters;
	}

	public String getX() {
		return x;
	}

	public void setX(String x) {
		this.x = x;
	}

	public String getY() {
		return y;
	}

	public void setY(String y) {
		this.y = y;
	}
}
