/*
 * Created on 5/09/2006
 * Indentification, VersionInfo, and CompilerInfo are completely ignored
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class FBDKFBType extends CommonInformation {

	private Identification identification = null;

	private CompilerInfo compilerInfo = null;
	private FBInterfaceList interfaceList;
	private BasicFB basicFB;
	private FBNetwork fbNetwork;
	private Service service = null;

	// Use Integer from 0 as Key
	private Hashtable<Integer, VersionInfo> versionInfos = new Hashtable<Integer, VersionInfo>();

	public FBDKFBType(String Name, String Comment,
			Identification identification,
			Hashtable<Integer, VersionInfo> versionInfos,
			CompilerInfo compilerInfo, FBInterfaceList interfaceList,
			BasicFB basicFB, Service service) {
		super(Name, Comment);
		this.identification = identification;
		this.versionInfos = versionInfos;
		this.compilerInfo = compilerInfo;
		this.interfaceList = interfaceList;
		this.basicFB = basicFB;
		this.service = service;
	}

	public FBDKFBType(String Name, String Comment,
			Identification identification,
			Hashtable<Integer, VersionInfo> versionInfos,
			CompilerInfo compilerInfo, FBInterfaceList interfaceList,
			FBNetwork fbNetwork, Service service) {
		super(Name, Comment);
		this.identification = identification;
		this.versionInfos = versionInfos;
		this.compilerInfo = compilerInfo;
		this.interfaceList = interfaceList;
		this.fbNetwork = fbNetwork;
		this.service = service;
	}

	// A service FB
	public FBDKFBType(String Name, String Comment,
			Identification identification,
			Hashtable<Integer, VersionInfo> versionInfos,
			CompilerInfo compilerInfo, FBInterfaceList interfaceList,
			Service service) {
		super(Name, Comment);
		this.identification = identification;
		this.versionInfos = versionInfos;
		this.compilerInfo = compilerInfo;
		this.interfaceList = interfaceList;
		this.service = service;
	}

	// A FBType only contains interface
	public FBDKFBType(String Name, String Comment,
			Identification identification,
			Hashtable<Integer, VersionInfo> versionInfos,
			CompilerInfo compilerInfo, FBInterfaceList interfaceList) {
		super(Name, Comment);
		this.identification = identification;
		this.versionInfos = versionInfos;
		this.compilerInfo = compilerInfo;
		this.interfaceList = interfaceList;
	}

	public String toString() {
		return "FBDKFBType";
	}

	public Element toXML() {
		Element fbdkFBTypeElement = new Element("FBType");

		fbdkFBTypeElement.setAttribute("Name", Name);
		if(Comment != null)
			fbdkFBTypeElement.setAttribute("Comment", Comment);

		if(identification != null) {
			fbdkFBTypeElement.addContent(identification.toXML());
		}

		for(VersionInfo versionInfo : versionInfos.values()) {
			fbdkFBTypeElement.addContent(versionInfo.toXML());
		}

		if(compilerInfo != null) {
			fbdkFBTypeElement.addContent(compilerInfo.toXML());
		}

		fbdkFBTypeElement.addContent(interfaceList.toXML());

		if(basicFB != null) {
			fbdkFBTypeElement.addContent(basicFB.toXML());
		}
		else if(fbNetwork != null) {
			fbdkFBTypeElement.addContent(fbNetwork.toXML());
		}

		if(service != null) {
			fbdkFBTypeElement.addContent(service.toXML());
		}

		return fbdkFBTypeElement;
	}

	public void print() {
		super.print();
		if(identification != null) {
			identification.print();
		}
		for(VersionInfo versionInfo : versionInfos.values()) {
			versionInfo.print();
		}
		if(compilerInfo != null) {
			compilerInfo.print();
		}
		interfaceList.print();
		if(basicFB != null) {
			basicFB.print();
		}
		else {
			fbNetwork.print();
		}
		if(service != null) {
			service.print();
		}
	}

	public BasicFB getBasicFB() {
		return basicFB;
	}

	public void setBasicFB(BasicFB basicFB) {
		this.basicFB = basicFB;
	}

	public FBNetwork getFbNetwork() {
		return fbNetwork;
	}

	public void setFbNetwork(FBNetwork fbNetwork) {
		this.fbNetwork = fbNetwork;
	}

	public FBInterfaceList getInterfaceList() {
		return interfaceList;
	}

	public void setInterfaceList(FBInterfaceList interfaceList) {
		this.interfaceList = interfaceList;
	}

	public Service getService() {
		return service;
	}

	public void setService(Service service) {
		this.service = service;
	}

	public CompilerInfo getCompilerInfo() {
		return compilerInfo;
	}

	public void setCompilerInfo(CompilerInfo compilerInfo) {
		this.compilerInfo = compilerInfo;
	}

	public Identification getIdentification() {
		return identification;
	}

	public void setIdentification(Identification identification) {
		this.identification = identification;
	}

	public Hashtable<Integer, VersionInfo> getVersionInfos() {
		return versionInfos;
	}

	public void setVersionInfos(Hashtable<Integer, VersionInfo> versionInfos) {
		this.versionInfos = versionInfos;
	}
}
