/*
 * Created on 25/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class FBEvent extends CommonInformation {
	private String Type = null;
	// Key starts from 0 to infinity
	private Hashtable<Integer, With> withs = null;

	public FBEvent(String Name, String Type, String Comment,
			Hashtable<Integer, With> withs) {
		super(Name, Comment);
		this.withs = withs;
		this.Type = Type;
	}

	public Element toXML() {
		Element eventElement = new Element("Event");
		eventElement.setAttribute("Name", Name);
		if(Type != null)
			eventElement.setAttribute("Type", Type);
		if(Comment != null)
			eventElement.setAttribute("Comment", Comment);
		if(withs != null) {
			for(With with : withs.values()) {
				eventElement.addContent(with.toXML());
			}
		}

		// Object[] withObjs = withs.values().toArray();
		// for(int j = withObjs.length - 1; j > -1; j--) {
		// eventElement.addContent(((With) withObjs[j]).toXML());
		// }

		return eventElement;
	}

	public void print() {
		super.print();
		System.out.println("Type: " + Type);
		if(withs != null) {
			for(With with : withs.values()) {
				with.print();
			}
		}
	}

	public String getType() {
		return Type;
	}

	public void setType(String Type) {
		this.Type = Type;
	}

	public Hashtable<Integer, With> getWiths() {
		return withs;
	}

	public void setWiths(Hashtable<Integer, With> withs) {
		this.withs = withs;
	}
}
