/*
 * Created on 25/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class FBEventInputs {

	// Use Event's Name as Key
	private Hashtable<String, FBEvent> events;

	public FBEventInputs(Hashtable<String, FBEvent> events) {
		if(events.isEmpty()) {
			// If the input XML file passed the XML schema validation, this
			// error shouldn't appear
			System.err.println("events in EventInputs is empty");
			System.exit(0);
		}
		else {
			this.events = events;
		}
	}

	public String toString() {
		return "EventInputs";
	}

	public Element toXML() {
		Element eventInputsElement = new Element("EventInputs");

		for(FBEvent event : events.values()) {
			eventInputsElement.addContent(event.toXML());
		}

		// Object[] eventObjs = events.values().toArray();
		// for(int j = eventObjs.length - 1; j > -1; j--) {
		// eventInputsElement.addContent(((Event) eventObjs[j]).toXML());
		// }

		return eventInputsElement;
	}

	public void print() {
		for(FBEvent event : events.values()) {
			event.print();
		}
	}

	public Hashtable<String, FBEvent> getEvents() {
		return events;
	}

	public void setEvents(Hashtable<String, FBEvent> events) {
		this.events = events;
	}

}
