/*
 * Created on 25/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class FBEventOutputs {

	private Hashtable<String, FBEvent> events;

	public FBEventOutputs(Hashtable<String, FBEvent> events) {
		if(events.isEmpty()) {
			// If the input XML file passed the XML schema validation, this
			// error shouldn't appear
			System.err.println("events in EventOutputs is empty");
			System.exit(0);
		}
		else {
			this.events = events;
		}
	}

	public String toString() {
		return "EventOutputs";
	}

	public Element toXML() {
		Element eventOutputsElement = new Element("EventOutputs");

		for(FBEvent event : events.values()) {
			eventOutputsElement.addContent(event.toXML());
		}

		// Object[] eventObjs = events.values().toArray();
		// for(int j = eventObjs.length - 1; j > -1; j--) {
		// eventOutputsElement.addContent(((Event) eventObjs[j]).toXML());
		// }

		return eventOutputsElement;
	}

	public void print() {
		for(FBEvent event : events.values()) {
			event.print();
		}
	}

	public Hashtable<String, FBEvent> getEvents() {
		return events;
	}

	public void setEvents(Hashtable<String, FBEvent> events) {
		this.events = events;
	}

}
