/*
 * Created on 26/01/2007
 */

package fbtypes;

import org.jdom.Element;

public class FBInterfaceList {
	private FBEventInputs eventInputs = null;
	private FBEventOutputs eventOutputs = null;
	private FBInputVars inputVars = null;
	private FBOutputVars outputVars = null;
	private Sockets sockets = null;
	private Plugs plugs = null;

	public FBInterfaceList(FBEventInputs eventInputs, FBEventOutputs eventOutputs,
			FBInputVars inputVars, FBOutputVars outputVars, Sockets sockets,
			Plugs plugs) {
		this.eventInputs = eventInputs;
		this.eventOutputs = eventOutputs;
		this.inputVars = inputVars;
		this.outputVars = outputVars;
		this.sockets = sockets;
		this.plugs = plugs;
	}

	public String toString() {
		return "InterfaceList";
	}

	public Element toXML() {
		Element interfaceListElement = new Element("InterfaceList");

		if(eventInputs != null)
			interfaceListElement.addContent(eventInputs.toXML());

		if(eventOutputs != null)
			interfaceListElement.addContent(eventOutputs.toXML());

		if(inputVars != null)
			interfaceListElement.addContent(inputVars.toXML());

		if(outputVars != null)
			interfaceListElement.addContent(outputVars.toXML());

		if(sockets != null)
			interfaceListElement.addContent(sockets.toXML());

		if(plugs != null)
			interfaceListElement.addContent(plugs.toXML());

		return interfaceListElement;
	}

	public void print() {
		if(eventInputs != null)
			eventInputs.print();
		else
			System.out.println("eventInputs is empty");

		if(eventOutputs != null)
			eventOutputs.print();
		else
			System.out.println("eventOutputs is empty");

		if(inputVars != null)
			inputVars.print();
		else
			System.out.println("inputVars is empty");

		if(outputVars != null)
			outputVars.print();
		else
			System.out.println("outputVars is empty");

		if(sockets != null)
			sockets.print();
		else
			System.out.println("sockets is empty");

		if(plugs != null)
			plugs.print();
		else
			System.out.println("plugs is empty");
	}

	public FBEventInputs getEventInputs() {
		return eventInputs;
	}

	public void setEventInputs(FBEventInputs eventInputs) {
		this.eventInputs = eventInputs;
	}

	public FBEventOutputs getEventOutputs() {
		return eventOutputs;
	}

	public void setEventOutputs(FBEventOutputs eventOutputs) {
		this.eventOutputs = eventOutputs;
	}

	public FBInputVars getInputVars() {
		return inputVars;
	}

	public void setInputVars(FBInputVars inputVars) {
		this.inputVars = inputVars;
	}

	public FBOutputVars getOutputVars() {
		return outputVars;
	}

	public void setOutputVars(FBOutputVars outputVars) {
		this.outputVars = outputVars;
	}

	public Plugs getPlugs() {
		return plugs;
	}

	public void setPlugs(Plugs plugs) {
		this.plugs = plugs;
	}

	public Sockets getSockets() {
		return sockets;
	}

	public void setSockets(Sockets sockets) {
		this.sockets = sockets;
	}
}
