/*
 * Created on 26/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class FBNetwork {

	// Use Name as Key for fbs
	private Hashtable<String, FB> fbs = null;
	private EventConnections eventConnections = null;
	private DataConnections dataConnections = null;
	private AdapterConnections adapterConnections = null;

	public FBNetwork(Hashtable<String, FB> fbs,
			EventConnections eventConnections, DataConnections dataConnections,
			AdapterConnections adapterConnections) {
		this.fbs = fbs;
		this.eventConnections = eventConnections;
		this.dataConnections = dataConnections;
		this.adapterConnections = adapterConnections;
	}

	public String toString() {
		return "FBNetwork";
	}

	public Element toXML() {
		Element fbNetworkElement = new Element("FBNetwork");

		if(fbs != null) {
			for(FB fb : fbs.values()) {
				fbNetworkElement.addContent(fb.toXML());
			}
		}
		if(eventConnections != null) {
			fbNetworkElement.addContent(eventConnections.toXML());
		}
		if(dataConnections != null) {
			fbNetworkElement.addContent(dataConnections.toXML());
		}
		if(adapterConnections != null) {
			fbNetworkElement.addContent(adapterConnections.toXML());
		}
		return fbNetworkElement;
	}

	public void print() {
		if(fbs != null) {
			for(FB fb : fbs.values()) {
				fb.print();
			}
		}
		if(eventConnections != null) {
			eventConnections.print();
		}
		if(dataConnections != null) {
			dataConnections.print();
		}
		if(adapterConnections != null) {
			adapterConnections.print();
		}
	}

	public AdapterConnections getAdapterConnections() {
		return adapterConnections;
	}

	public void setAdapterConnections(AdapterConnections adapterConnections) {
		this.adapterConnections = adapterConnections;
	}

	public DataConnections getDataConnections() {
		return dataConnections;
	}

	public void setDataConnections(DataConnections dataConnections) {
		this.dataConnections = dataConnections;
	}

	public EventConnections getEventConnections() {
		return eventConnections;
	}

	public void setEventConnections(EventConnections eventConnections) {
		this.eventConnections = eventConnections;
	}

	public Hashtable<String, FB> getFbs() {
		return fbs;
	}

	public void setFbs(Hashtable<String, FB> fbs) {
		this.fbs = fbs;
	}
}
