/*
 * Created on 25/01/2007
 */

package fbtypes;

import org.jdom.Element;

public class FBVarDeclaration extends CommonInformation {

	private String ArraySize = null;
	private String InitialValue = null;
	private String Type;

	public FBVarDeclaration(String Name, String Type, String ArraySize,
			String InitialValue, String Comment) {
		super(Name, Comment);
		this.Type = Type;
		if(ArraySize != null) {
			this.ArraySize = ArraySize;
		}
		if(InitialValue != null) {
			this.InitialValue = InitialValue;
		}
	}

	public Element toXML() {
		Element varDeclarationElement = new Element("VarDeclaration");

		varDeclarationElement.setAttribute("Name", Name);
		varDeclarationElement.setAttribute("Type", Type);

		if(ArraySize != null)
			varDeclarationElement.setAttribute("ArraySize", ArraySize);
		if(Comment != null)
			varDeclarationElement.setAttribute("Comment", Comment);
		if(InitialValue != null)
			varDeclarationElement.setAttribute("InitialValue", InitialValue);

		return varDeclarationElement;
	}

	public void print() {
		System.out.println("Name: " + Name);
		System.out.println("Type: " + Type);
		System.out.println("ArraySize: " + ArraySize);
		System.out.println("Comment: " + Comment);
		System.out.println("InitialValue: " + InitialValue);
	}

	public String getArraySize() {
		return ArraySize;
	}

	public void setArraySize(String arraySize) {
		ArraySize = arraySize;
	}

	public String getInitialValue() {
		return InitialValue;
	}

	public void setInitialValue(String initialValue) {
		InitialValue = initialValue;
	}

	public String getType() {
		return Type;
	}

	public void setType(String type) {
		Type = type;
	}

}
