/*
 * Created on 26/01/2007
 */

package fbtypes;

import org.jdom.Element;

public class InputPrimitive {
	private String Interface;
	private String Event;
	private String Parameters = null;

	public InputPrimitive(String Interface, String Event, String Parameters) {
		this.Interface = Interface;
		this.Event = Event;
		if(Parameters != null) {
			this.Parameters = Parameters;
		}
	}

	public String toString() {
		return "InputPrimitive";
	}

	public Element toXML() {
		Element inputPrimitiveElement = new Element("InputPrimitive");

		inputPrimitiveElement.setAttribute("Interface", Interface);
		inputPrimitiveElement.setAttribute("Event", Event);
		if(Parameters != null)
			inputPrimitiveElement.setAttribute("Parameters", Parameters);

		return inputPrimitiveElement;
	}

	public void print() {
		System.out.println("Interface: " + Interface);
		System.out.println("Event: " + Event);
		System.out.println("Parameters: " + Parameters);
	}

	public String getEvent() {
		return Event;
	}

	public void setEvent(String event) {
		Event = event;
	}

	public String getInterface() {
		return Interface;
	}

	public void setInterface(String interface1) {
		Interface = interface1;
	}

	public String getParameters() {
		return Parameters;
	}

	public void setParameters(String parameters) {
		Parameters = parameters;
	}
}
