/*
 * Created on 26/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class Service {
	private String RightInterface;
	private String LeftInterface;
	private String Comment = null;
	// Use Name as Key for serviceSequences
	private Hashtable<String, ServiceSequence> serviceSequences;

	public Service(String RightInterface, String LeftInterface, String Comment,
			Hashtable<String, ServiceSequence> serviceSequences) {
		this.RightInterface = RightInterface;
		this.LeftInterface = LeftInterface;
		if(Comment != null) {
			this.Comment = Comment;
		}
		if(serviceSequences.isEmpty()) {
			System.err.println("serviceSequences in Service is empty");
			System.exit(0);
		}
		else {
			this.serviceSequences = serviceSequences;
		}
	}

	public String toString() {
		return "Service";
	}

	public Element toXML() {
		Element serviceElement = new Element("Service");

		serviceElement.setAttribute("RightInterface", RightInterface);
		serviceElement.setAttribute("LeftInterface", LeftInterface);
		if(Comment != null)
			serviceElement.setAttribute("Comment", Comment);

		for(ServiceSequence serviceSequence : serviceSequences.values()) {
			serviceElement.addContent(serviceSequence.toXML());
		}

		return serviceElement;
	}

	public void print() {
		System.out.println("RightInterface: " + RightInterface);
		System.out.println("LeftInterface: " + LeftInterface);
		System.out.println("Comment: " + Comment);
		for(ServiceSequence serviceSequence : serviceSequences.values()) {
			serviceSequence.print();
		}
	}

	public String getComment() {
		return Comment;
	}

	public void setComment(String comment) {
		Comment = comment;
	}

	public String getLeftInterface() {
		return LeftInterface;
	}

	public void setLeftInterface(String leftInterface) {
		LeftInterface = leftInterface;
	}

	public String getRightInterface() {
		return RightInterface;
	}

	public void setRightInterface(String rightInterface) {
		RightInterface = rightInterface;
	}

	public Hashtable<String, ServiceSequence> getServiceSequences() {
		return serviceSequences;
	}

	public void setServiceSequences(
			Hashtable<String, ServiceSequence> serviceSequences) {
		this.serviceSequences = serviceSequences;
	}
}
