/*
 * Created on 26/01/2007
 */

package fbtypes;

import java.util.Hashtable;

import org.jdom.Element;

public class ServiceSequence extends CommonInformation {

	// Use Integer from 0 as Key
	private Hashtable<Integer, ServiceTransaction> serviceTransactions = null;

	public ServiceSequence(String Name, String Comment,
			Hashtable<Integer, ServiceTransaction> serviceTransactions) {
		super(Name, Comment);
		this.serviceTransactions = serviceTransactions;
	}

	public String toString() {
		return "ServiceSequence";
	}

	public Element toXML() {
		Element serviceSequenceElement = new Element("ServiceSequence");

		serviceSequenceElement.setAttribute("Name", Name);
		if(Comment != null)
			serviceSequenceElement.setAttribute("Comment", Comment);

		if(serviceTransactions != null) {
			for(ServiceTransaction serviceTransaction : serviceTransactions
					.values()) {
				serviceSequenceElement.addContent(serviceTransaction.toXML());
			}
		}

		return serviceSequenceElement;
	}

	public void print() {
		System.out.println("Name: " + Name);
		System.out.println("Comment: " + Comment);
		if(serviceTransactions != null) {
			for(ServiceTransaction serviceTransaction : serviceTransactions
					.values()) {
				serviceTransaction.print();
			}
		}
	}

	public Hashtable<Integer, ServiceTransaction> getServiceTransactions() {
		return serviceTransactions;
	}

	public void setServiceTransactions(
			Hashtable<Integer, ServiceTransaction> serviceTransactions) {
		this.serviceTransactions = serviceTransactions;
	}

}
