/*
 * Created on 29/01/2007
 */

package fbtypes;

import org.jdom.Element;

public class VersionInfo {

	private String Organization;
	private String Version;
	private String Author;
	private String Date;
	private String Remarks = null;

	public VersionInfo(String Organization, String Version, String Author,
			String Date, String Remarks) {
		this.Organization = Organization;
		this.Version = Version;
		this.Author = Author;
		this.Date = Date;
		if(Remarks != null) {
			this.Remarks = Remarks;
		}
	}

	public String toString() {
		return "VersionInfo";
	}

	public Element toXML() {
		Element versionInfoElement = new Element("VersionInfo");

		versionInfoElement.setAttribute("Organization", Organization);
		versionInfoElement.setAttribute("Version", Version);
		versionInfoElement.setAttribute("Author", Author);
		versionInfoElement.setAttribute("Date", Date);
		if(Remarks != null) {
			versionInfoElement.setAttribute("Remarks", Remarks);
		}
		return versionInfoElement;
	}

	public void print() {
		System.out.println("Organization: " + Organization);
		System.out.println("Version: " + Version);
		System.out.println("Author: " + Author);
		System.out.println("Date: " + Date);
		System.out.println("Remarks: " + Remarks);
	}	

	public String getAuthor() {
		return Author;
	}

	public void setAuthor(String author) {
		Author = author;
	}

	public String getDate() {
		return Date;
	}

	public void setDate(String date) {
		Date = date;
	}

	public String getOrganization() {
		return Organization;
	}

	public void setOrganization(String organization) {
		Organization = organization;
	}

	public String getRemarks() {
		return Remarks;
	}

	public void setRemarks(String remarks) {
		Remarks = remarks;
	}

	public String getVersion() {
		return Version;
	}

	public void setVersion(String version) {
		Version = version;
	}
}
