//Copyright (c) 2007 University of Auckland
//Contributed to the FBench extension of the OOONEIDA Workbench project under the Common Public License

package org.oooneida.wb;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import javax.swing.*;

// Referenced classes of package fb.tools.swing.editor:
//			FBJHelp

public abstract class CompilerAction extends JDialog
	implements ActionListener
{

	public CompilerAction(Frame parent, boolean modal)
	{
		super(parent, modal);
		status = new JTextField(30);
		panel = new JPanel();
		buttonPanel = new JPanel();
		okButton = new JButton("OK");
		cancelButton = new JButton("Cancel");
		cancelled = false;
		final CompilerAction me = this;
		addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent e)
			{
				restoreElement();
				cancelled = true;
				me.closeWindow();
			}

		});
		initComponents();
	}

	protected void initComponents()
	{
		setDefaultCloseOperation(2);
		getContentPane().setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();
		status.setEditable(false);
		status.setForeground(Color.blue);
		status.setFont(new Font("Times New Roman", 1, 12));
		gbc.weightx = 1.0D;
		gbc.fill = 2;
		getContentPane().add(status, gbc);
		gbc.gridy = 1;
		gbc.weighty = 1.0D;
		gbc.fill = 1;
		getContentPane().add(panel, gbc);
		panel.setLayout(new GridBagLayout());
		gbc.gridy = 2;
		gbc.weighty = 0.0D;
		gbc.fill = 2;
		buttonPanel.setLayout(new FlowLayout(1));
		okButton.addActionListener(this);
		buttonPanel.add(okButton);
		cancelButton.addActionListener(this);
		buttonPanel.add(cancelButton);
		getContentPane().add(buttonPanel, gbc);
	}

	public void closeWindow()
	{
		setVisible(false);
		dispose();
	}

	public void actionPerformed(ActionEvent e)
	{
		Object src = e.getSource();
		if(src == cancelButton)
		{
			cancelled = true;
			restoreElement();
			closeWindow();
		} else
		if(isUpdateRequest(src))
		{
			updateElement();
			if(checkElement())
				closeWindow();
			else
				restoreElement2();
		}
	}

	protected boolean isUpdateRequest(Object src)
	{
		return src == okButton;
	}

	public boolean wasUpdated()
	{
		return false;
	}

	protected void warn(String s)
	{
		status.setText(s);
		status.setCaretPosition(0);
		Toolkit.getDefaultToolkit().beep();
	}

	protected void updateElement()
	{
	}

	protected boolean checkElement()
	{
		return true;
	}

	protected void restoreElement()
	{
	}

	protected void restoreElement2()
	{
		restoreElement();
	}

	public boolean wasCancelled()
	{
		return cancelled;
	}

	public void showCentered()
	{
		Rectangle r = getParent().getBounds();
		Dimension sz = getPreferredSize();
		int w = sz.width;
		int h = sz.height;
		setBounds(r.x + (r.width - w) / 2, r.y + (r.height - h) / 2, w, h);
		setVisible(true);
	}

	protected JTextField status;
	protected JPanel panel;
	protected JPanel buttonPanel;
	protected JButton okButton;
	protected JButton cancelButton;
	protected boolean cancelled;
}