//Copyright (c) 2007 University of Auckland
//Contributed to the FBench extension of the OOONEIDA Workbench project under the Common Public License

package org.oooneida.wb;

import fb.tools.FileLibrary;
import java.io.File;
import javax.swing.Icon;
import javax.swing.filechooser.FileView;

/**
 * IEC 61499 File Type Icon Library

 * @author WD
 *
 * @version 20061126/WD
 */
public class FBIconLibrary extends FileView
{

    public static final String descriptions[] = {
        "Function Block Type", "Function Template", "Adapter Type", "Resource Type", "Device Type", "System Configuration", "Data Type", "XML File", "SRC File"
    };
    public static final String iconNames[] = {
        "fbicon", "ft16", "fb16", "res16", "dev16", "sys16", "var16", "xmlObject"
    };

    public FBIconLibrary()
    {
    }

    public String getDescription(File f)
    {
        int n = FBLibrary.getSuffixNumber(f);
        if(n < 0)
            return super.getDescription(f);
        else
            return "IEC 61499 " + descriptions[n];
    }

    public Icon getIcon(File f)
    {
        int n = FBLibrary.getSuffixNumber(f);
        if(n < 0 || n >= iconNames.length)
            return super.getIcon(f);
        else
            return ImageIconBank.get(iconNames[n]);
    }

    public String getName(File f)
    {
        int n = FBLibrary.getSuffixNumber(f);
        if(n < 0)
        {
            return super.getName(f);
        } else
        {
            String fname = f.getName();
            return fname.substring(0, fname.length() - FileLibrary.suffixes[n].length());
        }
    }

}
