//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb;

import java.net.URL;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.ImageIcon;

/**
 * A repository of ImageIcons.
 * 
 * @author JHC
 * @version 20050810/JHC - Made ".gif" the default suffix.
 * @version 20050414/JHC
 */
public class IconFactory {
	private static Vector icons = new Vector(32);

	private IconFactory() {
		super();
		getIcon("default");
	}

	/**
	 * Retrieve an icon with the given name from the repository.
	 * If the icon name does not have a suffix, the <TT>".gif"</TT> suffix is added.
	 */
	public static ImageIcon getIcon(String name) {
		if(name.indexOf('.')<0) name += ".gif";
		ImageIcon icon;
		for (Enumeration e = icons.elements(); e.hasMoreElements();) {
			icon = (ImageIcon) e.nextElement();
			if (icon.getDescription().equals(name))
				return icon;
		}
		URL iconURL = ClassLoader.getSystemClassLoader().getResource(
				"org/oooneida/wb/images/" + name);
		if (iconURL == null)
			return getIcon("default");
		icon = new ImageIcon(iconURL, name);
		icons.addElement(icon);
		return icon;
	}
}
