//Copyright (c) 2007 University of Auckland
//Contributed to the FBench extension of the OOONEIDA Workbench project under the Common Public License

package org.oooneida.wb;

import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;

/**
 * Generate XML data of org.w3c.dom.Element variable
 * @author JP
 * 
 * @version 20070301/JP
 */

public class XMLCodeGenerator {
	private static String content;
	private static String indent;

	public static String getXML(Element rootElement){
		content = new String();
		indent = new String();
		createXML(rootElement);
		return content;
	}

	private static void createXML(Element node){
		content = content + indent + "<"+node.getNodeName()+" ";
		NamedNodeMap nodeAttributes = node.getAttributes();
		
		if(node.getNodeName().equals("Algorithm"))
			System.out.println(((Element)node.getFirstChild()).getAttribute("Text"));
		
		//TODO: Rearrange the order of attributes appropriately
		for(int i = 0; i < nodeAttributes.getLength(); i++){
			String attributeName = nodeAttributes.item(i).getNodeName();
			String attributeVal =
				//node.getAttribute(attributeName);
				replaceReservedCharacters(node.getAttribute(attributeName));
			content = content + (attributeName+"="+"\""+attributeVal+"\" ");
		}
		if(node.hasChildNodes()) content = content + ">\n";
		else content = content + "/>\n";

		indent = indent + "   ";
		for(int i = 0; i < node.getChildNodes().getLength(); i++){
			createXML((Element)node.getChildNodes().item(i));
		}
		indent = indent.replaceFirst("   ", "");

		if(node.getChildNodes().getLength() != 0) content = content + indent + "</"+node.getNodeName()+">\n";
		return;
	}
	/**
	 * 
	 * @param attribute
	 * @return
	 */
	public static String replaceReservedCharacters(String attribute){
		/*
		attribute = attribute.replaceAll("&", "&amp;");
		attribute = attribute.replaceAll(">", "&gt;");
		attribute = attribute.replaceAll("<", "&lt;");
		attribute = attribute.replaceAll("\n", "<br>");
		attribute = attribute.replaceAll("\"", "&quot;");
		*/
		
		attribute = attribute.replaceAll("&", "&#38;");
		attribute = attribute.replaceAll("\n", "&#10;");
		attribute = attribute.replaceAll("\"", "&#34;");
		attribute = attribute.replaceAll(">", "&#62;");
		attribute = attribute.replaceAll("<", "&#60;");
		attribute = attribute.replaceAll("'", "&#39;");
		
		return attribute;
	}
}