<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Copyright (c)2005 Holobloc Inc. -->
<!-- Contributed to the OOONEIDA Workbench project under the Common Public License. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="text"/>
	<!-- Document Template -->
	<xsl:template match="/">
		<xsl:apply-templates/>
	</xsl:template>
	<!-- Utility templates -->
	<xsl:template name="indent4">
		<xsl:call-template name="indent2"/>
		<xsl:call-template name="indent2"/>
	</xsl:template>
	<xsl:template name="indent2">
		<xsl:text disable-output-escaping="yes">
			&amp;nbsp;&amp;nbsp;
		</xsl:text>
	</xsl:template>
	<xsl:template name="break">
		<xsl:text disable-output-escaping="yes">&lt;BR&gt;</xsl:text>
	</xsl:template>
	<!-- Top Level Templates -->
	<xsl:template match="/FBType">
		<xsl:value-of select="CompilerInfo/@header"/>
		<xsl:call-template name="break"/>
		import fb.datatype.*;
		<xsl:call-template name="break"/>
		import fb.rt.*;
		<xsl:call-template name="break"/>
		import fb.rt.net.*;
		<xsl:call-template name="break"/>
		import fb.rt.events.*;
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
		public class
		<xsl:value-of select="@Name"/>
		extends FBInstance {
		<xsl:call-template name="break"/>
		<xsl:apply-templates/>
		<xsl:call-template name="break"/>
		<xsl:if test="//FBNetwork">
			<xsl:call-template name="break"/>
			<!-- Constructor -->
			public
			<xsl:value-of select="@Name"/>
			() {
			<xsl:call-template name="break"/>
			super();
			<xsl:call-template name="break"/>
			<xsl:for-each select="//VarDeclaration">
				<xsl:if test="@InitialValue!=''">
					<xsl:value-of select="@Name"/>
					.initializeNoException("<xsl:value-of select="@InitialValue"/>");
				</xsl:if>
			</xsl:for-each>
			<xsl:call-template name="break"/>
			<xsl:for-each select="//EventConnections/Connection">
				<xsl:value-of select="@Source"/>
				.connectTo(
				<xsl:value-of select="@Destination"/>
				);
				<xsl:call-template name="break"/>
			</xsl:for-each>
			<xsl:call-template name="break"/>
			<xsl:for-each select="//DataConnections/Connection">
				<xsl:if test="contains(@Source,'.')">
					<xsl:if test="contains(@Destination,'.')">
						<xsl:call-template name="ConnData">
							<xsl:with-param name="INobj" select="substring-before(@Source,'.')"/>
							<xsl:with-param name="INvar" select="substring-after(@Source,'.')"/>
							<xsl:with-param name="OUTobj" select="substring-before(@Destination,'.')"/>
							<xsl:with-param name="OUTvar" select="substring-after(@Destination,'.')"/>
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="not(contains(@Destination,'.'))">
						<xsl:call-template name="ConnData">
							<xsl:with-param name="INobj" select="substring-before(@Source,'.')"/>
							<xsl:with-param name="INvar" select="substring-after(@Source,'.')"/>
							<xsl:with-param name="OUTobj"/>
							<xsl:with-param name="OUTvar" select="@Destination"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:if>
				<xsl:if test="not(contains(@Source,'.'))">
					<xsl:if test="contains(@Destination,'.')">
						<xsl:call-template name="ConnData">
							<xsl:with-param name="INobj"/>
							<xsl:with-param name="INvar" select="@Source"/>
							<xsl:with-param name="OUTobj" select="substring-before(@Destination,'.')"/>
							<xsl:with-param name="OUTvar" select="substring-after(@Destination,'.')"/>
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="not(contains(@Destination,'.'))">
						<xsl:call-template name="ConnData">
							<xsl:with-param name="INobj"/>
							<xsl:with-param name="INvar" select="@Source"/>
							<xsl:with-param name="OUTobj"/>
							<xsl:with-param name="OUTvar" select="@Destination"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="//FB">
				<xsl:if test="Parameter">
					<xsl:value-of select="@Name"/>
					.
					<xsl:value-of select="Parameter/@Name"/>
					.initializeNoException("<xsl:value-of select="Parameter/@Value"/>");
					<xsl:call-template name="break"/>
				</xsl:if>
			</xsl:for-each>
			}
			<xsl:call-template name="break"/>
			<xsl:call-template name="break"/>
		</xsl:if>
		<xsl:if test="//ECC">
			<!-- serviceEvent functions -->
			public void serviceEvent(EventServer eventserver){
			<xsl:call-template name="break"/>
			<xsl:for-each select="//EventInputs/Event">
				if (eventserver==
				<xsl:value-of select="@Name"/>
				) { 
					service_<xsl:value-of select="@Name"/>(); 
				}
				<xsl:call-template name="break"/>
			</xsl:for-each>
			}
			<xsl:call-template name="break"/>
			<xsl:call-template name="break"/>
			<!-- service_??() -->
			<xsl:for-each select="//EventInputs/Event">
				public void service_<xsl:value-of select="@Name"/>() {
				<xsl:call-template name="break"/>
				<xsl:call-template name="ECTrans">
					<xsl:with-param name="Eventname" select="@Name"/>
				</xsl:call-template>
				<xsl:call-template name="break"/>
				}
				<xsl:call-template name="break"/>
				<xsl:call-template name="break"/>
			</xsl:for-each>
			<!-- Algorithm -->
			<xsl:for-each select="//Algorithm">
				public void alg_<xsl:value-of select="@Name"/>() {
				<xsl:call-template name="break"/>
				<xsl:value-of select="Other/@Text" />
				<xsl:call-template name="break"/>
				}
				<xsl:call-template name="break"/>
			</xsl:for-each>
			<!-- Constructor -->
			public
			<xsl:value-of select="@Name"/>
			() {
			<xsl:call-template name="break"/>
			super();
			<xsl:call-template name="break"/>
			<xsl:for-each select="//VarDeclaration">
				<xsl:if test="@InitialValue!=''">
					<xsl:value-of select="@Name"/>
					.initializeNoException("<xsl:value-of select="@InitialValue"/>");
				</xsl:if>
			</xsl:for-each>
			<xsl:call-template name="break"/>
			}
			<xsl:call-template name="break"/>
			<xsl:call-template name="break"/>
		</xsl:if>
		}
	</xsl:template>
	<xsl:template name="ConnData">
		<xsl:param name="INobj"/>
		<xsl:param name="INvar"/>
		<xsl:param name="OUTobj"/>
		<xsl:param name="OUTvar"/>
		<xsl:if test="$INobj!=''">
			<xsl:if test="$OUTobj!=''">
				<xsl:value-of select="$OUTobj"/>
				.connectIVNoException("<xsl:value-of select="$OUTvar"/>",
				<xsl:value-of select="$INobj"/>
				.ovNamedNoException("<xsl:value-of select="$INvar"/>"));
				<xsl:call-template name="break"/>
			</xsl:if>
			<xsl:if test="$OUTobj=''">
				<xsl:for-each select="//OutputVars/VarDeclaration">
					<xsl:if test="@Name=$OUTvar">
						<xsl:value-of select="$OUTvar"/>
						= (
						<xsl:value-of select="@Type"/>
						)
						<xsl:value-of select="$INobj"/>
						.ovNamedNoException("<xsl:value-of select="$INvar"/>");
						<xsl:call-template name="break"/>
					</xsl:if>
				</xsl:for-each>
				<xsl:call-template name="break"/>
			</xsl:if>
		</xsl:if>
		<xsl:if test="$INobj=''">
			<xsl:if test="$OUTobj!=''">
				<xsl:value-of select="$OUTobj"/>
				.connectIVNoException("<xsl:value-of select="$INvar"/>",
				<xsl:value-of select="$OUTvar"/>
				);
				<xsl:call-template name="break"/>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	<xsl:template match="/DeviceType">
		public class
		<xsl:value-of select="@Name"/>
		extends FBDevice {
		<xsl:call-template name="break"/>
		<xsl:apply-templates/>
		}
	</xsl:template>
	<xsl:template match="/ResourceType">
		public class
		<xsl:value-of select="@Name"/>
		extends FBResource {
		<xsl:call-template name="break"/>
		<xsl:apply-templates/>
		}
	</xsl:template>
	<xsl:template match="/AdapterType">
		public class
		<xsl:value-of select="@Name"/>
		extends FBAdapter {
		<xsl:call-template name="break"/>
		<xsl:apply-templates/>
		}
	</xsl:template>
	<xsl:template match="/System"/>
	<!-- ECTransitions -->
	<xsl:template name="ECTrans">
		<xsl:param name="Eventname"/>
		<xsl:for-each select="//ECTransition">
			<xsl:choose>
				<xsl:when test="(@Condition)=($Eventname)">
					if (eccState == index_<xsl:value-of select="@Source"/>) {
					<xsl:call-template name="break"/>
					state_<xsl:value-of select="@Destination"/>();
					<xsl:call-template name="break"/>
					return;
					<xsl:call-template name="break"/>
					}
					<xsl:call-template name="break"/>
				</xsl:when>
				<xsl:when test="contains(@Condition,$Eventname)">
					if ((eccState == index_<xsl:value-of select="@Source"/>) &amp;&amp; (
					<!-- Receive ECState Condition -->
					<xsl:value-of select="substring-after(@Condition,'&amp;')"/>
					)) {
					<xsl:call-template name="break"/>
					state_<xsl:value-of select="@Destination"/>();
					<xsl:call-template name="break"/>
					return;
					<xsl:call-template name="break"/>
					}
					<xsl:call-template name="break"/>
				</xsl:when>
				<xsl:otherwise/>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	<!-- ECTransitions handle 1 back -->
	<xsl:template name="ECTrans2">
		<xsl:param name="Eventname"/>
		<xsl:for-each select="//ECTransition[(@Source)=($Eventname)]">
			<xsl:choose>
				<xsl:when test="(@Condition)='1'">
					<xsl:choose>
						<xsl:when test="(@Source)='START'">
							<xsl:call-template name="break"/>
							if (
							<xsl:value-of select="@Condition"/>
							) state_<xsl:value-of select="@Destination"/>();
							<xsl:call-template name="break"/>
						</xsl:when>
						<xsl:otherwise>
							state_<xsl:value-of select="@Destination"/>();
							<xsl:call-template name="break"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise/>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	<!-- ECC -->
	<xsl:template match="ECC">
		<xsl:call-template name="break"/>
		<xsl:for-each select="ECState">
			private static final int index_<xsl:value-of select="@Name"/>
			<xsl:text> = </xsl:text>
			<xsl:number/>;
			<xsl:call-template name="break"/>
			private void state_<xsl:value-of select="@Name"/>() {
			<xsl:call-template name="break"/>
			eccState = index_<xsl:value-of select="@Name"/>;
			<xsl:call-template name="break"/>
			<xsl:if test="ECAction/@Output!=''">
				<xsl:value-of select="ECAction/@Output"/>
				.serviceEvent(this);
				<xsl:call-template name="break"/>
			</xsl:if>
			<xsl:if test="ECAction/@Algorithm!=''">
				alg_<xsl:value-of select="ECAction/@Algorithm"/>();
				<xsl:call-template name="break"/>
			</xsl:if>
			<xsl:call-template name="ECTrans2">
				<xsl:with-param name="Eventname" select="@Name"/>
			</xsl:call-template>
			}
			<xsl:call-template name="break"/>
			<xsl:call-template name="break"/>
		</xsl:for-each>
		<xsl:call-template name="break"/>
	</xsl:template>
	<!-- Event Interface -->
	<xsl:template match="EventInputs">
		<xsl:call-template name="break"/>
		<xsl:for-each select="Event">
			<xsl:choose>
				<xsl:when test="//FBNetwork">
					public EventOutput
					<xsl:value-of select="@Name"/>
					<xsl:text> = new EventOutput();</xsl:text>
					<xsl:call-template name="break"/>
				</xsl:when>
				<xsl:otherwise>
					public EventServer
					<xsl:value-of select="@Name"/>
					<xsl:text> = new EventInput(this);</xsl:text>
					<xsl:call-template name="break"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:call-template name="break"/>
		</xsl:for-each>
		<xsl:call-template name="break"/>
		public EventServer eiNamed(String s) {
		<xsl:call-template name="break"/>
		<xsl:for-each select="Event">
			if (s.equals("<xsl:value-of select="@Name"/>")) return <xsl:value-of select="@Name"/>;
			<xsl:call-template name="break"/>
		</xsl:for-each>
		return super.eiNamed(s); 
		<xsl:call-template name="break"/>
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
	</xsl:template>
	<xsl:template match="EventOutputs">
		<xsl:for-each select="Event">
			public EventOutput
			<xsl:value-of select="@Name"/>
			<xsl:text> = new EventOutput();</xsl:text>
			<xsl:call-template name="break"/>
		</xsl:for-each>
		<xsl:call-template name="break"/>
		public EventOutput eoNamed(String s) {
		<xsl:call-template name="break"/>
		<xsl:for-each select="Event">
			if (s.equals("<xsl:value-of select="@Name"/>")) return
			<xsl:value-of select="@Name"/>
			;
			<xsl:call-template name="break"/>
		</xsl:for-each>
		return super.eoNamed(s);
		<xsl:call-template name="break"/> 
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
	</xsl:template>
	<!-- Variable Interface -->
	<xsl:template match="InputVars">
		<xsl:apply-templates/>
		public ANY ivNamed(String s) throws FBRManagementException {
		<xsl:call-template name="break"/>
		<xsl:for-each select="VarDeclaration">
			if (s.equals("<xsl:value-of select="@Name"/>")) return
			<xsl:value-of select="@Name"/>
			;
			<xsl:call-template name="break"/>
		</xsl:for-each>
		return super.ivNamed(s); 
		<xsl:call-template name="break"/>
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
		public void connectIV(String ivName, ANY newIV) throws
		FBRManagementException {
		<xsl:call-template name="break"/>
		<xsl:for-each select="VarDeclaration">
			if(ivName.equals("<xsl:value-of select="@Name"/>")){
				connect_<xsl:value-of select="@Name"/>
			((
			<xsl:value-of select="@Type"/>
			)newIV); 
			<xsl:call-template name="break"/>
			return;
			<xsl:call-template name="break"/>
			}
		<xsl:call-template name="break"/>
		</xsl:for-each>
		super.connectIV(ivName, newIV); 
		<xsl:call-template name="break"/>
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
		<xsl:for-each select="VarDeclaration">
			public void connect_<xsl:value-of select="@Name"/>
			(
			<xsl:value-of select="@Type"/>
			newIV) throws FBRManagementException{
			<xsl:call-template name="break"/>
			<xsl:value-of select="@Name"/>
			<xsl:text> = newIV; 
			<xsl:call-template name="break"/>
			}</xsl:text>
			<xsl:call-template name="break"/>
		</xsl:for-each>
		<xsl:call-template name="break"/>
	</xsl:template>
	<xsl:template match="OutputVars">
		<xsl:apply-templates/>
		public ANY ovNamed(String s) throws FBRManagementException {
		<xsl:call-template name="break"/>
		<xsl:for-each select="VarDeclaration">
			if (s.equals("<xsl:value-of select="@Name"/>")) return <xsl:value-of select="@Name"/>;
			<xsl:call-template name="break"/>
		</xsl:for-each>
		return super.ovNamed(s); 
		<xsl:call-template name="break"/>
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
	</xsl:template>
	<xsl:template match="VarDeclaration">
		public
		<xsl:value-of select="@Type"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select="@Name"/>
		<xsl:text> = new </xsl:text>
		<xsl:value-of select="@Type"/>
		<xsl:if test="@ArraySize">
			<!-- TODO @ArraySize-->
		</xsl:if>
		(
		<xsl:if test="@InitialValue">
			<!--TODO @InitialValue -->
		</xsl:if>
		);
		<xsl:call-template name="break"/>
	</xsl:template>
	<!-- FBNetworks -->
	<xsl:template match="FBNetwork">
		<xsl:apply-templates/>
		<xsl:call-template name="break"/>
		public void initialize(String fbName, Resource r) throws
		FBRManagementException {
		<xsl:call-template name="break"/>
		super.initialize(fbName,r);
		<xsl:call-template name="break"/>
		<xsl:for-each select="FB">
			<xsl:value-of select="@Name"/>
			.initialize("<xsl:value-of select="@Name"/>",r);
			<xsl:call-template name="break"/>
		</xsl:for-each>
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
		public void start() {
		<xsl:call-template name="break"/>
		<xsl:for-each select="FB">
			<xsl:value-of select="@Name"/>
			.start();
			<xsl:call-template name="break"/>
		</xsl:for-each>
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
		public void stop() {
		<xsl:call-template name="break"/>
		<xsl:for-each select="FB">
			<xsl:value-of select="@Name"/>
			.stop();
			<xsl:call-template name="break"/>
		</xsl:for-each>
		}
		<xsl:call-template name="break"/>
		<xsl:call-template name="break"/>
	</xsl:template>
	<xsl:template match="FB">
		public
		<xsl:value-of select="@Type"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select="@Name"/>
		<xsl:text> = new </xsl:text>
		<xsl:value-of select="@Type"/>
		();
		<xsl:call-template name="break"/>
	</xsl:template>
	<xsl:template match="Parameter">
		<!-- TODO in constructor -->
	</xsl:template>
	<xsl:template match="EventConnections">
		<!-- TODO in constructor -->
	</xsl:template>
	<xsl:template match="DataConnections">
		<!-- TODO in constructor -->
	</xsl:template>
	<xsl:template match="AdapterConnections">
		<!-- TODO in constructor -->
	</xsl:template>
	<xsl:template match="Connection">
		<!-- TODO in constructor -->
	</xsl:template>
</xsl:stylesheet>
