//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.dom.events;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.events.MutationEvent;

/**
 * A listener for MutationEvents from an ECC and its children.
 * 
 * @author JHC
 * @version 20051111/JHC
 */
public class ECC extends MutationListener {

    public ECC() {
        super();
    }

    public ECC(Element el) {
        super(el);
    }

    protected void processNameChange(MutationEvent mutev, Element el) {
        String oldname = mutev.getPrevValue();
        String newname = mutev.getNewValue();
        NodeList conns = getElement().getElementsByTagName("ECTransition");
        for (int i = 0; i < conns.getLength(); i++) {
            Element conn = (Element) conns.item(i);
            if (conn.getAttribute("Source").equals(oldname))
                conn.setAttribute("Source", newname);
            if (conn.getAttribute("Destination").equals(oldname))
                conn.setAttribute("Destination", newname);
        }
    }
}
