//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.dom.events;

import org.w3c.dom.Element;

import com.sun.org.apache.xerces.internal.dom.events.EventImpl;

/**
 * A cancelable, bubbling DOM Level 2 Event representing the selection of an
 * Element from a UI.
 * 
 * @author JHC
 * @version 20051110/JHC
 */
public class ElementSelectionEvent extends org.apache.xerces.dom.events.EventImpl {
    private int detail = 0;

    private Element selectedElement = null;

    private Object source = null;

    /** The detail code for activation, e.g., mouse click. */
    public static final int ACTIVATE = 1;

    /** The detail code for hyperactivation, e.g., double click. */
    public static final int HYPERACTIVATE = 2;

    public ElementSelectionEvent() {
        super();
    }

    public int getDetail() {
        return detail;
    }

    public Element getSelectedElement() {
        return selectedElement;
    }

    public Object getSource() {
        return source;
    }

    /**
     * Initialize the selection event.
     * 
     * @param selectedElementArg The selected DOM Element.
     * @param sourceArg The source of the selection (typically a Component).
     * @param detailArg The selection type (ACTIVATE or HYPERACTIVATE).
     */
    public void initSelectionEvent(Element selectedElementArg,
            Object sourceArg, int detailArg) {
        super.initEvent("ElementSelectionEvent", true, true);
        selectedElement = selectedElementArg;
        source = sourceArg;
        detail = detailArg;
    }
}
