//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.dom.events;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.events.MutationEvent;

/**
 * A listener for MutationEvents from an FBNetwork and its children.
 * 
 * @author JHC
 * @version 20051111/JHC
 */
public class FBNetwork extends MutationListener {

    public FBNetwork() {
        super();
    }

    public FBNetwork(Element el) {
        super(el);
    }

    protected void processNameChange(MutationEvent mutev, Element el) {
        String oldname = mutev.getPrevValue();
        String newname = mutev.getNewValue();
        String[] lnames = { "EventConnections", "DataConnections",
                "AdapterConnections" };
        for (int k = 0; k < lnames.length; k++) {
            NodeList conns = getElement().getElementsByTagName(lnames[k]);
            if (conns.getLength() == 0)
                continue;
            conns = ((Element) conns.item(0)).getChildNodes();
            for (int i = 0; i < conns.getLength(); i++) {
                Element conn = (Element) conns.item(i);
                String[] attnames = { "Source", "Destination" };
                for (int j = 0; j < attnames.length; j++) {
                    String att = conn.getAttribute(attnames[j]);
                    if (att.startsWith((oldname + '.')))
                        conn.setAttribute(attnames[j], newname
                                + att.substring(oldname.length()));
                }
            }
        }
    }
}
