//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.dom.events;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.events.MutationEvent;

/**
 * A listener for MutationEvents from a System configuration and its children.
 * 
 * @author JHC
 * @version 20051111/JHC
 */
public class System extends MutationListener {

    public System() {
        super();
    }

    public System(Element el) {
        super(el);
    }

    protected void processNameChange(MutationEvent mutev, Element el) {
        String oldname = mutev.getPrevValue();
        String newname = mutev.getNewValue();
        NodeList conns = getElement().getElementsByTagName("Link");
        for (int i = 0; i < conns.getLength(); i++) {
            Element conn = (Element) conns.item(i);
            if (conn.getAttribute("SegmentName").equals(oldname))
                conn.setAttribute("SegmentName", newname);
            if (conn.getAttribute("CommResource").equals(oldname))
                conn.setAttribute("CommResource", newname);
        }
    }
}
