//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.graph;

import java.awt.BorderLayout;
import java.awt.event.MouseListener;

import javax.swing.JLabel;
import org.oooneida.wb.IconFactory;
import org.w3c.dom.Element;

/**
 * A GraphNode containing the label for an InputPrimitive of a ServiceSequence.
 * 
 * @author JHC
 * @version 20051104/JHC
 */
public class InputPrimitive extends Event {

    public InputPrimitive() {
        super();
    }

    public String mainLabelText() {
        return getElement().getAttribute("Event");
    }

    protected void initComponents() {
        super.initComponents();
        mainLabel.setIcon(IconFactory.getIcon(getIconName()));
        mainLabel.setHorizontalTextPosition(isLeftInterface() ? JLabel.LEFT
                : JLabel.RIGHT);
        add(mainLabel, BorderLayout.CENTER);
        Element el = getElement();
        setToolTipText(el.getAttribute("Interface") + '.'
                + el.getAttribute("Event") + '('
                + el.getAttribute("Parameters") + ')');
        resetMouseListner();
    }

    protected String getIconName() {
        return isLeftInterface() ? "arrow15r" : "arrow15l";
    }

    public boolean isLeftInterface() {
        Element service = (Element) getElement().getParentNode()
                .getParentNode().getParentNode();
        return getElement().getAttribute("Interface").equals(
                service.getAttribute("LeftInterface"));
    }
}
