//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.graph;

import java.awt.Component;
import java.awt.Point;


/**
 * A graphical representation of a network Link.
 * 
 * @author JHC
 * @version 20050701/JHC
 */
public class Link extends GraphEdge {

    public Link() {
        super();
    }

    public Point getSourcePoint() {
        Point s = super.getSourcePoint();
        if (s == null)
            return null;
        Point d = super.getDestPoint();
        if (d == null)
            return null;
        return new Point(d.x, s.y);
    }
	
    public Component getSource() {
		return source;
	}
	
	public Component getDest() {
		return dest;
	}
    
    /**
     * Returns <TT>true</TT> if the given point is within 3 units of the line
     * from source to destination. If the line cannot be determined, answers
     * <TT>false</TT>.
     */
    public boolean contains(int x, int y) {
        if (Math.abs(x) > 3)
            return false;
        return (y > 0) && (y < getBounds().height);
    }

    protected Component getEndPtComponent(boolean findSource) {
        String attname = findSource? "SegmentName":"CommResource";
        return getNodeNamed(getElement().getAttribute(attname));
    }

}
