//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.

//Copyright (c) 2007 University of Auckland
//Contributed to the FBench extension of the OOONEIDA Workbench project under the Common Public License

package org.oooneida.wb.graph;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import org.oooneida.wb.FBench;
import org.w3c.dom.NodeList;

/**
 * A graphic element that encapsulates an ElementModel for an IEC 61499 <TT>
 * ResourceType</TT> library Element.
 * 
 * @author JHC, JP
 * 
 * @version 20070301/JP - Double click on mainlabel opens calls FBench to open the selected FBType
 * @version 20051027/JHC - Deferred all <TT>updateShape()</TT> operations to
 *          superclass.
 * @version 20051004/JHC
 */
public class ResourceType extends FBType {

    public ResourceType() {
        super();
    }

    protected void initComponents() {
        super.initComponents();
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.insets = new Insets(2, 2, 2, 2);
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.gridwidth = 2;
        add(mainLabel, gbc);
        mainLabel.addMouseListener(new MouseAdapter(){            
        	public void mouseClicked(MouseEvent evt) {
        		processMousePress();
        		if(evt.getButton() == MouseEvent.BUTTON1 && evt.getClickCount() == 2){
        			try{
        				Container parent = getParent();
        				while(!parent.getClass().toString().endsWith("org.oooneida.wb.FBench")){
        					parent = parent.getParent();
        				}
        				FBench FBench = (FBench)parent;
        				FBench.open(mainLabel.getText());
        			}
        			catch (NullPointerException e){	}
        		}
        	}
        });
        NodeList vars = getElement().getElementsByTagName("VarDeclaration");
        gbc.gridx = 0;
        gbc.gridy = 1;
        addInterfaceElements(vars, gbc);
    }

}
