//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.graph;

import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.awt.geom.Area;
import java.awt.geom.GeneralPath;

/**
 * A graphical representation of a network Segment.
 * 
 * @author JHC
 * @version 20050701/JHC
 */
public class Segment extends GraphNode {
    private GeneralPath path = new GeneralPath();
    public Segment() {
        super();
        setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
        mainLabel.setOpaque(false);
    }

    public Rectangle getPreferredBounds() {
        Rectangle ans = super.getPreferredBounds();
        ans.y -= ans.height / 2;
        ans.width = Math.round(getScaledAtt("dx1"));
        ans.x -= ans.width / 2;
        return ans;
    }

    protected void initComponents() {
        super.initComponents();
        add(mainLabel);
    }

    protected String mainLabelText() {
        return model.getName() + " : " + model.getType();
    }
    protected void updateShape(){
        path.reset();
        float h = getHeight()-1;
        float h2 = h/2;
        float w = getWidth()-1;
        path.moveTo(0,h2);
        path.lineTo(h2,0);
        path.lineTo(w-h2,0);
        path.lineTo(w,h2);
        path.lineTo(w-h2,h);
        path.lineTo(h2,h);
        path.closePath();
        outline.reset();
        outline.add(new Area(path));
    }
}
