//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.graph;

import java.awt.BorderLayout;

import javax.swing.JLabel;

import org.oooneida.wb.IconFactory;
import org.w3c.dom.Element;

/**
 * A GraphNode containing the labels for a ServiceSequence.
 * 
 * @author JHC
 * @version 20051103/JHC
 */
public class ServiceSequence extends Event {
    public ServiceSequence(Element el) {
        super();
        setElement(el);
    }

    protected void initComponents() {
        super.initComponents();
        add(mainLabel,BorderLayout.NORTH);
        Element parel = (Element)getElement().getParentNode();
        JLabel lbl = new JLabel(parel.getAttribute("LeftInterface"));
        lbl.setFont(GraphView.DEFAULT_FONT);
        lbl.setOpaque(false);
        add(lbl,BorderLayout.WEST);
        lbl = new JLabel(IconFactory.getIcon("sp30"));
        lbl.setOpaque(false);
        add(lbl,BorderLayout.CENTER);
        lbl = new JLabel(parel.getAttribute("RightInterface"));
        lbl.setFont(GraphView.DEFAULT_FONT);
        lbl.setOpaque(false);
        add(lbl,BorderLayout.EAST);
    }

    public String mainLabelText() {
        return model.getName();
    }
}
