//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench Project under the terms of the Common Public License.
//See http://oooneida-wb.sourceforge.net.
package org.oooneida.wb.graph.model;

import java.util.Vector;

import org.oooneida.wb.Library;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * A GraphModel for a Resource instance.
 * 
 * @author JHC
 * @version 20051113/JHC
 */
public class Resource extends GraphModel {
	Element typeDocElement = null;

	public Resource() {
		super();
	}

	public Resource(Element el) {
		super(el);
	}

	public Vector getGraph() {
		Vector graph = new Vector();
		addNetworkElements(graph, getTypeDocElement());
		addNetworkElements(graph, getElement());
		return graph;
	}

	protected void addNetworkElements(Vector graph, Element el) {
		if (el == null)
			return;
		NodeList nl = el.getChildNodes();
		for(int i=0; i<nl.getLength();i++){
			Element el2 = (Element)nl.item(i);
			if(el2.getTagName().equals("FBNetwork")){
				GraphModel gm = GraphModel.graphModelForElement(el2);
				if (gm != null)
					graph.addAll(gm.getGraph());
				return;
			}
		}
	}

	/**
	 * Returns the DocumentElement of the receiver's Type document with lazy
	 * initialization.
	 */
	protected Element getTypeDocElement() {
		if (typeDocElement != null)
			return typeDocElement;
		Document doc = Library.getDocument(getType() + getTypeSuffix());
		if (doc == null)
			return null;
		typeDocElement = doc.getDocumentElement();
		return typeDocElement;
	}

	/**
	 * Returns the suffix (including the initial period) for the element's Type
	 * file.
	 */
	protected String getTypeSuffix() {
		return ".res";
	}
}
