//Copyright (c) 2007 University of Auckland
//Contributed to the FBench extension of the OOONEIDA Workbench project under the Common Public License

package org.oooneida.wb.translate;

public class ParseError {

	private boolean isCritical;
	private int line;
	private String message;

	public ParseError(int line, String message, boolean critical) {
		this.isCritical = critical;
		this.line = line;
		this.message = message;
	}

	public boolean isCritical() {
		return isCritical;
	}

	public String getMessage() {
		return message;
	}

	public int getLine() {
		return line;
	}
	
	public String toString(){
		String result = "(" + line + ") ";
		if(isCritical)
			result += "Error: ";
		else
			result += "Warning: ";
		result += message;
		return result;
	}

	public boolean equals(Object obj) {
		if (!(obj instanceof ParseError)) return false;
		ParseError theObj = (ParseError)obj;
		return isCritical == theObj.isCritical() &&
			line == theObj.getLine() &&
			message.equals(theObj.getMessage());
	}
}