//### This file created by BYACC 1.8(/Java extension  1.14)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package org.oooneida.wb.translate;



//#line 2 "st.y"
  import java.io.*;
  import java.util.*;
  import java.util.regex.*;
  import org.oooneida.wb.translate.Translator;
//#line 22 "STtoJava.java"




public class STtoJava
             implements Translator
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//public class STtoJavaVal is defined in STtoJavaVal.java


String   yytext;//user variable to return contextual strings
STtoJavaVal yyval; //used to return semantic vals from action routines
STtoJavaVal yylval;//the 'lval' (result) I got from yylex()
STtoJavaVal valstk[];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
void val_init()
{
  valstk=new STtoJavaVal[YYSTACKSIZE];
  yyval=new STtoJavaVal();
  yylval=new STtoJavaVal();
  valptr=-1;
}
void val_push(STtoJavaVal val)
{
  if (valptr>=YYSTACKSIZE)
    return;
  valstk[++valptr]=val;
}
STtoJavaVal val_pop()
{
  if (valptr<0)
    return new STtoJavaVal();
  return valstk[valptr--];
}
void val_drop(int cnt)
{
int ptr;
  ptr=valptr-cnt;
  if (ptr<0)
    return;
  valptr = ptr;
}
STtoJavaVal val_peek(int relative)
{
int ptr;
  ptr=valptr-relative;
  if (ptr<0)
    return new STtoJavaVal();
  return valstk[ptr];
}
//#### end semantic value section ####
public final static short NewLine=257;
public final static short WhiteSpace=258;
public final static short Not=259;
public final static short And=260;
public final static short Or=261;
public final static short Mod=262;
public final static short Xor=263;
public final static short Power=264;
public final static short Type=265;
public final static short Of=266;
public final static short Struct=267;
public final static short Array=268;
public final static short EndStruct=269;
public final static short Function=270;
public final static short VarInput=271;
public final static short VarOutput=272;
public final static short VarInputOutput=273;
public final static short EndVar=274;
public final static short EndType=275;
public final static short Return=276;
public final static short EndFunction=277;
public final static short If=278;
public final static short Then=279;
public final static short Else=280;
public final static short ElseIf=281;
public final static short EndIf=282;
public final static short Case=283;
public final static short EndCase=284;
public final static short For=285;
public final static short To=286;
public final static short By=287;
public final static short EndFor=288;
public final static short While=289;
public final static short Do=290;
public final static short EndWhile=291;
public final static short Repeat=292;
public final static short Until=293;
public final static short Exit=294;
public final static short Comma=295;
public final static short Colon=296;
public final static short SemiColon=297;
public final static short OParen=298;
public final static short CParen=299;
public final static short OBracket=300;
public final static short CBracket=301;
public final static short OBrace=302;
public final static short CBrace=303;
public final static short Point=304;
public final static short Plus=305;
public final static short Minus=306;
public final static short Asterisk=307;
public final static short FSlash=308;
public final static short Equal=309;
public final static short NotEqual=310;
public final static short LessThan=311;
public final static short LessThanEqualTo=312;
public final static short GreaterThan=313;
public final static short GreaterThanEqualTo=314;
public final static short Assign=315;
public final static short Range=316;
public final static short Error=317;
public final static short NumSeparator=318;
public final static short DirectRep=319;
public final static short Action=320;
public final static short EndAction=321;
public final static short At=322;
public final static short Constant=323;
public final static short En=324;
public final static short Eno=325;
public final static short FEdge=326;
public final static short InitialStep=327;
public final static short EndStep=328;
public final static short Program=329;
public final static short With=330;
public final static short EndProgram=331;
public final static short REdge=332;
public final static short ReadOnly=333;
public final static short ReadWrite=334;
public final static short Resource=335;
public final static short EndResource=336;
public final static short Retain=337;
public final static short Step=338;
public final static short Task=339;
public final static short Transition=340;
public final static short EndTransition=341;
public final static short From=342;
public final static short VarExternal=343;
public final static short VarAccess=344;
public final static short VarGlobal=345;
public final static short BooleanLiteral=346;
public final static short IntegerLiteral=347;
public final static short LongLiteral=348;
public final static short FloatLiteral=349;
public final static short Identifier=350;
public final static short UnclosedStringLiteral=351;
public final static short CommentText=352;
public final static short StringLiteral=353;
public final static short CharLiteral=354;
public final static short UNARY=355;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    5,    5,    5,    6,    6,    6,   35,   36,   38,   38,
   39,   37,   25,   26,   26,   26,   26,   27,   28,   28,
   29,   30,   31,   31,   32,   33,   34,   34,    7,    7,
   10,   10,   10,   10,   11,   11,   12,   12,   42,   41,
   40,   40,   40,   40,   40,   40,   43,   45,   44,   46,
   46,   47,   47,    8,    8,   13,   13,   13,   13,   14,
   15,   15,   16,   16,   17,   18,   18,   19,   19,    9,
    9,    9,    9,   20,   21,   21,   22,   23,    3,    3,
    3,    3,    3,    3,    3,    3,    0,    4,    4,    4,
    4,    4,    4,   24,    2,    2,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,
};
final static short yylen[] = {                            2,
    2,    4,    2,    1,    1,    1,    3,    3,    1,    3,
    4,    3,    6,    1,    1,    1,    1,    6,    1,    2,
    5,    5,    1,    3,    8,    8,    1,    3,    1,    1,
    4,    4,    4,    4,    1,    3,    1,    3,    7,    2,
    1,    1,    1,    3,    3,    3,    5,    5,    5,    4,
    3,    1,    3,    1,    1,    5,    7,    9,   11,    7,
    1,    2,    1,    2,    3,    1,    3,    1,    1,    1,
    1,    1,    1,    7,    3,    5,    5,    4,    1,    2,
    1,    1,    2,    2,    2,    2,    1,    1,    1,    2,
    2,    3,    1,    3,    1,    1,    1,    1,    1,    1,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    2,    2,    3,
};
final static short yydefred[] = {                         0,
   79,    0,    0,    0,    0,    0,    0,   30,    0,    0,
    0,    0,    0,   73,    0,    0,   98,   95,   96,   97,
    0,   88,    0,    0,  100,    0,    0,    0,    0,    0,
    0,    0,   29,   54,   55,   70,   71,   72,   81,    4,
    5,    6,   82,   99,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    3,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   90,    0,    0,   80,
   83,   84,   85,   86,    0,    0,    0,   35,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  118,    0,    0,
    0,    0,   12,    0,    9,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   92,    0,    0,   32,   33,   34,    0,    0,    0,
    0,    0,    0,    0,    0,   31,    0,    0,    0,    0,
   36,    0,    0,    0,    0,    0,   14,   15,   16,   17,
    0,    0,    0,   56,    0,    0,    0,   61,    0,   66,
   68,    0,    0,   77,    0,    0,   10,    0,    0,   23,
    0,    0,   13,    0,    0,    0,    0,    0,   41,   43,
   42,    0,    0,    0,   63,    0,    0,   62,    0,    0,
    0,    0,   11,    0,    0,   19,   27,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   39,   57,    0,   94,
    0,   60,   67,    0,    0,   74,    0,    0,   20,    0,
    0,   24,    0,    0,   52,    0,    0,    0,    0,   45,
   44,   46,    0,    0,    0,    0,   28,    0,   22,    0,
    0,    0,    0,    0,    0,    0,   58,    0,   18,    0,
    0,   47,    0,    0,    0,   48,   49,    0,   21,    0,
    0,    0,   50,   59,   26,   25,
};
final static short yydgoto[] = {                         23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
   87,   88,   34,   35,  157,  187,  158,  159,  160,   36,
  133,   37,   38,  161,   39,  146,  147,  195,  196,  148,
  171,  149,  150,  198,   40,   41,   42,  104,  105,  177,
  178,   43,  179,  180,  181,  253,  227,
};
final static short yysindex[] = {                      1455,
    0, -187, -292, -279, -276, -313, -308,    0, -187, -187,
 -301, -187, 1455,    0, -187, -187,    0,    0,    0,    0,
 -285,    0,    0, 1952,    0, -278, 1756, -246, -230, -220,
 -218, -213,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -157,  -30,  -30,  -30, -174, -152,
 1217, 1384, -170, 1101, 1569, 1791, -157,  -30, -128, -167,
    0, -187, -187, -187, -187, -187, -187, -187, -187, -187,
 -187, -187, -187, -187, -187, -187,    0, -285, -243,    0,
    0,    0,    0,    0, -166, 1952, -236,    0, -235, -233,
 -105, -194, 1455,  -88, -187, 1455, -187,    0, -183, -127,
 -126, 1952,    0, -121,    0, -106, 1559, 1328, -157, 1328,
 -157,  -83,  -83, -157, -157,  -51,  -51,  -51,  -51,  -51,
  -51,    0, -187,  -30,    0,    0,    0, -250,  -82,  -77,
 -206, 1822, -101, 1624, 1952,    0, -156, -153, 1952, 1952,
    0,  -62, -103, -148, -100,  -68,    0,    0,    0,    0,
  -41, 1455, -187,    0,    0, -102, -234,    0, -168,    0,
    0, -187, 1455,    0,  -89, -127,    0, -134, -182,    0,
 -178, -182,    0,  -34,  -29,  -18, 1530,  -50,    0,    0,
    0, 1660, 1858, -182,    0, 1455,  -39,    0, -206, 1455,
 1886, 1690,    0,  -49, -245,    0,    0, -251, -104,  -48,
  -66,  -99,  -99,  -99,  -41, 1756,    0,    0, 1455,    0,
 1756,    0,    0, 1756, -187,    0,  -98,  -44,    0, -182,
   -7,    0,   -9, -182,    0,    3, -158,    8,   12,    0,
    0,    0, 1494, 1952,  -27,   15,    0,  -76,    0,   -2,
 -272,  -99,  -75, -248, -227, 1455,    0,   42,    0,    5,
    6,    0,   47,   10,   24,    0,    0, 1720,    0,   65,
   66,  -99,    0,    0,    0,    0,
};
final static short yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1394,    0,    0, 1319,    0, 1206,  324,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    1,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   76,    0,    0,   28,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1281,    0,
    0,    0,    0,    0, 1767, -165,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1914,
 1941,   29,    0,   30,    0,    0, 1051, 1090,  151, 1165,
  226,  451,  526,  301,  376,  601,  676,  751,  826,  901,
  976,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   31,    0,    0,    0,   32, -159,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -241,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   40,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -249,   54,    0,    0,    0,    0,
   48,    0,    0, -223,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   44,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   39,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
final static short yygindex[] = {                         0,
   23, -116,  -24,  -13,    0,    0,    0,    0,    0,  -54,
  -38,  216,    0,    0,    0,    0,  186,    0,  155,    0,
    0,    0,    0, -162,    0,    0,    0,    0,  150,    0,
    0,    0,    0,    0,    0,    0,  -17,    0,  209,    0,
    0,    0,  167,  169,  172,   33,  136,
};
final static int YYTABLESIZE=2266;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                         55,
  117,  252,   79,   61,  103,   46,  197,   79,   89,   90,
   79,   79,   58,   79,  156,   79,  142,  143,   47,   99,
   79,   48,  185,  218,   45,  256,   79,   79,   79,   59,
   79,   51,   52,   79,   54,   79,   49,   56,   57,   79,
  156,   50,   79,  220,   79,  186,  257,  144,   53,  221,
   80,  103,  156,   69,   69,  201,   65,  237,  124,  124,
   61,  124,  125,  126,   60,  127,   81,  210,   86,   86,
   86,    2,  156,   77,   95,  116,   82,  225,   83,  130,
   86,  102,  134,   84,  107,  108,  109,  110,  111,  112,
  113,  114,  115,  116,  117,  118,  119,  120,  121,  145,
   79,  225,   79,  156,  194,   79,   66,  240,  122,   79,
   15,  124,  155,   19,   20,  136,  199,  132,   16,  135,
  200,   91,  225,   65,   65,   65,  189,  190,  139,   37,
    2,    3,    4,   37,    5,   38,  242,  243,  182,   38,
  155,   19,   20,   92,   95,  140,   86,  106,  123,  192,
  106,  128,    2,    3,    4,  129,    5,   79,   17,   18,
   19,   20,   44,  206,   18,   19,   20,   79,  131,   15,
  137,   58,  211,  138,  151,  183,  214,   16,   64,    1,
   66,   79,    3,    4,  191,    5,   79,    6,  163,   79,
  165,   15,    7,  166,  168,  233,  169,  172,    8,   16,
    9,  170,  152,  153,  154,   10,  173,   11,   79,  193,
   64,   12,   66,  184,   13,  194,   14,   17,  100,   19,
   20,  101,  202,   69,   70,  107,  207,  203,    2,  174,
  175,  176,  258,   79,  226,  228,  229,  234,  204,   17,
   18,   19,   20,  101,  212,  222,  217,  239,  223,  224,
  225,  235,  236,   67,   68,   69,   70,  117,  238,  241,
  117,  117,  117,  117,  244,  117,  117,   15,  245,  248,
  117,  249,   78,  250,  255,   16,  117,  117,  117,  117,
  117,  117,  117,  117,  117,  117,  117,  117,  117,  117,
  117,  117,  117,  117,  117,  117,  251,  117,  259,  117,
  104,  260,  261,  262,  242,  117,  117,  117,  117,  117,
  117,  117,  117,  117,  117,   17,   18,   19,   20,   85,
  263,  265,  266,   87,    1,    7,    8,   78,    2,   75,
   40,   64,  116,   76,   53,  116,  116,  116,  116,  141,
  116,  116,  188,  213,  219,  116,  167,  117,  117,  117,
  117,  116,  116,  116,  116,  116,  116,  116,  116,  116,
  116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
  116,  230,  116,  231,  116,  105,  232,  254,    0,    0,
  116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  106,    0,    0,
  106,  106,  106,  106,    0,  106,  106,    0,    0,    0,
  106,    0,  116,  116,  116,  116,  106,  106,  106,  106,
  106,  106,  106,  106,  106,  106,  106,  106,  106,  106,
  106,  106,  106,  106,  106,  106,    0,  106,    0,  106,
  102,    0,    0,    0,    0,  106,  106,  106,  106,  106,
  106,  106,  106,  106,  106,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  107,    0,    0,  107,  107,  107,  107,    0,
  107,  107,    0,    0,    0,  107,    0,  106,  106,  106,
  106,  107,  107,  107,  107,  107,  107,  107,  107,  107,
  107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
  107,    0,  107,    0,  107,  103,    0,    0,    0,    0,
  107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  104,    0,    0,
  104,  104,  104,  104,    0,  104,  104,    0,    0,    0,
  104,    0,  107,  107,  107,  107,  104,  104,  104,  104,
  104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
  104,  104,  104,  104,  104,  104,    0,  104,    0,  104,
  110,    0,    0,    0,    0,  104,  104,  104,  104,  104,
  104,  104,  104,  104,  104,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  105,    0,    0,  105,  105,  105,  105,    0,
  105,  105,    0,    0,    0,  105,    0,  104,  104,  104,
  104,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,    0,  105,    0,  105,  111,    0,    0,    0,    0,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  102,    0,    0,
  102,  102,    0,  102,    0,  102,  102,    0,    0,    0,
  102,    0,  105,  105,  105,  105,  102,  102,  102,  102,
  102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
  102,  102,  102,  102,  102,  102,    0,  102,    0,  102,
  112,    0,    0,    0,    0,  102,  102,    0,    0,  102,
  102,  102,  102,  102,  102,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  103,    0,    0,  103,  103,    0,  103,    0,
  103,  103,    0,    0,    0,  103,    0,  102,  102,  102,
  102,  103,  103,  103,  103,  103,  103,  103,  103,  103,
  103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
  103,    0,  103,    0,  103,  113,    0,    0,    0,    0,
  103,  103,    0,    0,  103,  103,  103,  103,  103,  103,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  110,    0,    0,
  110,  110,    0,  110,    0,  110,  110,    0,    0,    0,
  110,    0,  103,  103,  103,  103,  110,  110,  110,  110,
  110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
  110,  110,  110,  110,  110,  110,    0,  110,    0,  110,
  114,    0,    0,    0,    0,    0,    0,    0,    0,  110,
  110,  110,  110,  110,  110,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  111,    0,    0,  111,  111,    0,  111,    0,
  111,  111,    0,    0,    0,  111,    0,  110,  110,  110,
  110,  111,  111,  111,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
  111,    0,  111,    0,  111,  115,    0,    0,    0,    0,
    0,    0,    0,    0,  111,  111,  111,  111,  111,  111,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  112,    0,    0,
  112,  112,    0,  112,    0,  112,  112,    0,    0,    0,
  112,    0,  111,  111,  111,  111,  112,  112,  112,  112,
  112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
  112,  112,  112,  112,  112,  112,    0,  112,    0,  112,
  101,    0,    0,    0,    0,    0,    0,    0,    0,  112,
  112,  112,  112,  112,  112,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  113,    0,    0,  113,  113,    0,  113,  108,
  113,  113,    0,    0,    0,  113,    0,  112,  112,  112,
  112,  113,  113,  113,  113,  113,  113,  113,  113,  113,
  113,  113,  113,  113,  113,  113,  113,  113,  113,  113,
  113,    0,  113,    0,  113,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  113,  113,  113,  113,  113,  113,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  114,    0,    0,
  114,  114,    0,  114,  109,  114,  114,    0,    0,    0,
  114,    0,  113,  113,  113,  113,  114,  114,  114,  114,
  114,  114,  114,  114,  114,  114,  114,  114,  114,  114,
  114,  114,  114,  114,  114,  114,    0,  114,    0,  114,
    0,    0,    0,    0,    0,   89,    0,    0,    0,  114,
  114,  114,  114,  114,  114,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  115,    0,    0,  115,  115,    0,  115,    0,
  115,  115,    0,    0,    0,  115,    0,  114,  114,  114,
  114,  115,  115,  115,  115,  115,  115,  115,  115,  115,
  115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
  115,    0,  115,    0,  115,    0,    0,    0,    0,    0,
   91,    0,    0,    0,  115,  115,  115,  115,  115,  115,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  101,    0,    0,
  101,  101,    0,  101,    0,  101,  101,    0,   93,    0,
  101,    0,  115,  115,  115,  115,  101,  101,  101,  101,
  101,  101,  101,  101,  101,  101,  101,  101,  101,  101,
  101,  101,  101,  101,  101,  101,  108,  101,    0,  101,
  108,    0,  108,    0,  108,  108,    0,    0,    0,  108,
   62,   63,   64,   65,   66,  108,  108,  108,  108,  108,
  108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
  108,  108,  108,  108,  108,    0,  108,    0,  108,    0,
   96,    0,    0,   99,    0,    0,    0,  101,  101,  101,
  101,    0,    0,    0,    0,   67,   68,   69,   70,   71,
   72,   73,   74,   75,   76,    0,    0,    0,    0,    0,
    0,  109,    0,    0,    0,  109,    0,  109,    0,  109,
  109,    0,    0,    0,  109,    0,  108,  108,  108,  108,
  109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
  109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
    0,  109,   89,  109,    0,   89,   89,    0,   89,    0,
   89,    0,    0,    0,    0,   89,   62,   63,   64,   65,
   66,   89,   89,   89,    0,   89,   89,   89,   89,   89,
   89,    0,    0,   89,   89,   93,   89,   89,   89,   89,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  109,  109,  109,  109,    0,    0,    0,    0,    0,
    0,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,    0,    0,    0,    0,    0,    0,   91,    0,    0,
   91,   91,    0,   91,    0,   91,    0,    0,    0,    0,
   91,    0,   89,   89,   89,   89,   91,   91,   91,    0,
   91,   91,   91,   91,   91,   91,    0,    0,   91,   91,
    0,   91,   91,   91,   91,   93,    0,    0,    0,    0,
    0,    0,    0,   93,    0,    0,    0,   62,   93,   64,
    0,   66,    0,    0,   93,   93,   93,    0,   93,   93,
   93,   93,   93,   93,    0,    0,   93,   93,    0,   93,
   93,   93,   93,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   91,   91,   91,
   91,    0,   67,   68,   69,   70,   71,   72,   73,   74,
   75,   76,    0,   62,   63,   64,   65,   66,    0,   94,
   99,    0,    0,   99,   99,   99,   99,   99,   99,    0,
    0,    0,    0,   99,    0,   93,   93,   93,   93,   99,
   99,   99,    0,   99,   99,   99,   99,   99,   99,    0,
    0,   99,   99,    0,   99,   99,   99,   99,   67,   68,
   69,   70,   71,   72,   73,   74,   75,   76,   99,   99,
   99,   99,   99,   99,   99,   99,   99,   99,    0,    0,
    0,    1,    0,    2,    3,    4,    0,    5,    0,    6,
    0,    0,    0,    0,    7,    0,    0,    0,    0,    0,
    8,    0,    9,    0,    0,    0,    0,   10,    0,   11,
   99,   99,   99,   12,    0,    0,   13,    0,   14,    0,
    1,    0,   15,    3,    4,    0,    5,    0,    6,    0,
   16,    0,    0,    7,    0,    0,    0,    0,    0,    8,
    0,    9,    0,  246,    0,  247,   10,    0,   11,    0,
    0,    0,   12,    0,    0,   13,  205,   14,    2,    3,
    4,    0,    5,    0,    6,    0,    0,    0,    0,    7,
   17,   18,   19,   20,   21,    8,   22,    9,    0,    0,
    0,    0,   10,    0,   11,    0,    0,    0,   12,    0,
   64,   13,   66,   14,    0,    1,    0,   15,    3,    4,
    0,    5,    0,    6,    0,   16,    0,    0,    7,    0,
    0,    0,    0,   78,    8,    0,    9,    0,    0,    0,
    0,   10,    0,   11,    0,    0,    0,   12,    0,    0,
   13,   97,   14,   67,   68,   69,   70,   71,   72,   73,
   74,   75,   76,    0,    0,   17,   18,   19,   20,   21,
    1,   22,    0,    3,    4,    0,    5,    0,    6,    0,
    0,    0,    0,    7,    0,    0,    0,    0,    0,    8,
    0,    9,    0,    0,    0,    0,   10,    0,   11,    0,
    0,    0,   12,    0,  164,   13,    1,   14,   78,    3,
    4,    0,    5,    0,    6,    0,    0,    0,    0,    7,
    0,    0,    0,    0,    0,    8,    0,    9,    0,    0,
    0,  208,   10,    0,   11,    0,    1,    0,   12,    3,
    4,   13,    5,   14,    6,    0,    0,    0,    0,    7,
    0,    0,    0,    0,    0,    8,    0,    9,    0,    0,
    0,    0,   10,   78,   11,    0,    1,  216,   12,    3,
    4,   13,    5,   14,    6,    0,    0,    0,    0,    7,
    0,    0,    0,    0,    0,    8,    0,    9,    0,    0,
    0,  264,   10,    0,   11,    0,    0,    0,   12,   78,
    0,   13,    1,   14,    0,    3,    4,    0,    5,    0,
    6,    0,    0,    0,    0,    7,   99,   99,   99,   99,
   99,    8,    0,    9,    0,    0,    0,    0,   10,   78,
   11,    0,    0,    0,   12,    0,    0,   13,    0,   14,
   62,   63,   64,   65,   66,    0,    0,    0,    0,    0,
    0,   99,    0,    0,    0,   99,    0,    0,    0,   78,
    0,   99,   99,   99,   99,   99,   99,   99,   99,   99,
   99,   62,   63,   64,   65,   66,    0,    0,    0,   98,
    0,    0,    0,    0,    0,   67,   68,   69,   70,   71,
   72,   73,   74,   75,   76,   78,    0,  162,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   62,   63,   64,
   65,   66,    0,    0,    0,    0,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,  209,    0,    0,    0,
    0,    0,    0,    0,    0,   62,   63,   64,   65,   66,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   67,   68,   69,   70,   71,   72,   73,   74,
   75,   76,  215,   95,   95,   95,   95,   95,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
   99,   99,   99,   99,   99,    0,    0,    0,    0,    0,
   95,   62,   63,   64,   65,   66,    0,    0,   95,   95,
   95,   95,   95,   95,   95,   95,   95,   95,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   99,    0,    0,
    0,    0,    0,    0,    0,   99,   99,   99,   99,   99,
   99,   99,   99,   99,   99,    0,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                         13,
    0,  274,   27,   21,   59,  298,  169,  257,   47,   48,
  260,  261,  298,  263,  131,  265,  267,  268,  298,   58,
  270,  298,  257,  269,    2,  274,  276,  277,  278,  315,
   55,    9,   10,  283,   12,  285,  350,   15,   16,  289,
  157,  350,  292,  295,  294,  280,  274,  298,  350,  301,
  297,  106,  169,  295,  296,  172,  280,  220,  295,  295,
   78,  295,  299,  299,  350,  299,  297,  184,   46,   47,
   48,  259,  189,  352,  316,    0,  297,  350,  297,   93,
   58,   59,   96,  297,   62,   63,   64,   65,   66,   67,
   68,   69,   70,   71,   72,   73,   74,   75,   76,  350,
  350,  350,  352,  220,  350,  130,  264,  224,  352,  134,
  298,  295,  347,  348,  349,  299,  295,   95,  306,   97,
  299,  296,  350,  347,  348,  349,  295,  296,  106,  295,
  259,  260,  261,  299,  263,  295,  295,  296,  152,  299,
  347,  348,  349,  296,  315,  123,  124,  315,  315,  163,
    0,  257,  259,  260,  261,  350,  263,  182,  346,  347,
  348,  349,  350,  177,  347,  348,  349,  192,  257,  298,
  298,  298,  186,  295,  257,  153,  190,  306,  262,  257,
  264,  206,  260,  261,  162,  263,  211,  265,  290,  214,
  347,  298,  270,  347,  257,  209,  300,  298,  276,  306,
  278,  350,  280,  281,  282,  283,  275,  285,  233,  299,
  262,  289,  264,  316,  292,  350,  294,  346,  347,  348,
  349,  350,  257,  307,  308,    0,  277,  257,  259,  271,
  272,  273,  246,  258,  202,  203,  204,  215,  257,  346,
  347,  348,  349,  350,  284,  350,  296,  257,  297,  316,
  350,  350,  297,  305,  306,  307,  308,  257,  266,  257,
  260,  261,  262,  263,  257,  265,  266,  298,  257,  297,
  270,  257,  350,  350,  350,  306,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  299,  297,  257,  299,
    0,  297,  297,  257,  295,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  346,  347,  348,  349,  350,
  297,  257,  257,    0,  297,  297,  297,  297,  297,  290,
  277,  284,  257,  290,  296,  260,  261,  262,  263,  124,
  265,  266,  157,  189,  195,  270,  138,  347,  348,  349,
  350,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  205,  297,  205,  299,    0,  205,  242,   -1,   -1,
  305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,  262,  263,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,   -1,  297,   -1,  299,
    0,   -1,   -1,   -1,   -1,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,   -1,  260,  261,  262,  263,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  347,  348,  349,
  350,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,   -1,  297,   -1,  299,    0,   -1,   -1,   -1,   -1,
  305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,  262,  263,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,   -1,  297,   -1,  299,
    0,   -1,   -1,   -1,   -1,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,   -1,  260,  261,  262,  263,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  347,  348,  349,
  350,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,   -1,  297,   -1,  299,    0,   -1,   -1,   -1,   -1,
  305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,   -1,  263,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,   -1,  297,   -1,  299,
    0,   -1,   -1,   -1,   -1,  305,  306,   -1,   -1,  309,
  310,  311,  312,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,   -1,  260,  261,   -1,  263,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  347,  348,  349,
  350,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,   -1,  297,   -1,  299,    0,   -1,   -1,   -1,   -1,
  305,  306,   -1,   -1,  309,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,   -1,  263,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,   -1,  297,   -1,  299,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
  310,  311,  312,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,   -1,  260,  261,   -1,  263,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  347,  348,  349,
  350,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,   -1,  297,   -1,  299,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  309,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,   -1,  263,   -1,  265,  266,   -1,   -1,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,   -1,  297,   -1,  299,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
  310,  311,  312,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,   -1,  260,  261,   -1,  263,    0,
  265,  266,   -1,   -1,   -1,  270,   -1,  347,  348,  349,
  350,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,   -1,  297,   -1,  299,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  309,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,   -1,  263,    0,  265,  266,   -1,   -1,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,   -1,  297,   -1,  299,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,  309,
  310,  311,  312,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,   -1,  260,  261,   -1,  263,   -1,
  265,  266,   -1,   -1,   -1,  270,   -1,  347,  348,  349,
  350,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,   -1,  297,   -1,  299,   -1,   -1,   -1,   -1,   -1,
    0,   -1,   -1,   -1,  309,  310,  311,  312,  313,  314,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,   -1,  263,   -1,  265,  266,   -1,    0,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  257,  297,   -1,  299,
  261,   -1,  263,   -1,  265,  266,   -1,   -1,   -1,  270,
  260,  261,  262,  263,  264,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,   -1,  297,   -1,  299,   -1,
  290,   -1,   -1,    0,   -1,   -1,   -1,  347,  348,  349,
  350,   -1,   -1,   -1,   -1,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,   -1,   -1,  261,   -1,  263,   -1,  265,
  266,   -1,   -1,   -1,  270,   -1,  347,  348,  349,  350,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
   -1,  297,  257,  299,   -1,  260,  261,   -1,  263,   -1,
  265,   -1,   -1,   -1,   -1,  270,  260,  261,  262,  263,
  264,  276,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,   -1,   -1,  288,  289,  279,  291,  292,  293,  294,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  347,  348,  349,  350,   -1,   -1,   -1,   -1,   -1,
   -1,  305,  306,  307,  308,  309,  310,  311,  312,  313,
  314,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,   -1,  263,   -1,  265,   -1,   -1,   -1,   -1,
  270,   -1,  347,  348,  349,  350,  276,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,   -1,   -1,  288,  289,
   -1,  291,  292,  293,  294,  257,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  265,   -1,   -1,   -1,  260,  270,  262,
   -1,  264,   -1,   -1,  276,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,   -1,   -1,  288,  289,   -1,  291,
  292,  293,  294,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  347,  348,  349,
  350,   -1,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  314,   -1,  260,  261,  262,  263,  264,   -1,  266,
  257,   -1,   -1,  260,  261,  262,  263,  264,  265,   -1,
   -1,   -1,   -1,  270,   -1,  347,  348,  349,  350,  276,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,   -1,
   -1,  288,  289,   -1,  291,  292,  293,  294,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,   -1,   -1,
   -1,  257,   -1,  259,  260,  261,   -1,  263,   -1,  265,
   -1,   -1,   -1,   -1,  270,   -1,   -1,   -1,   -1,   -1,
  276,   -1,  278,   -1,   -1,   -1,   -1,  283,   -1,  285,
  347,  348,  349,  289,   -1,   -1,  292,   -1,  294,   -1,
  257,   -1,  298,  260,  261,   -1,  263,   -1,  265,   -1,
  306,   -1,   -1,  270,   -1,   -1,   -1,   -1,   -1,  276,
   -1,  278,   -1,  280,   -1,  282,  283,   -1,  285,   -1,
   -1,   -1,  289,   -1,   -1,  292,  257,  294,  259,  260,
  261,   -1,  263,   -1,  265,   -1,   -1,   -1,   -1,  270,
  346,  347,  348,  349,  350,  276,  352,  278,   -1,   -1,
   -1,   -1,  283,   -1,  285,   -1,   -1,   -1,  289,   -1,
  262,  292,  264,  294,   -1,  257,   -1,  298,  260,  261,
   -1,  263,   -1,  265,   -1,  306,   -1,   -1,  270,   -1,
   -1,   -1,   -1,  350,  276,   -1,  278,   -1,   -1,   -1,
   -1,  283,   -1,  285,   -1,   -1,   -1,  289,   -1,   -1,
  292,  293,  294,  305,  306,  307,  308,  309,  310,  311,
  312,  313,  314,   -1,   -1,  346,  347,  348,  349,  350,
  257,  352,   -1,  260,  261,   -1,  263,   -1,  265,   -1,
   -1,   -1,   -1,  270,   -1,   -1,   -1,   -1,   -1,  276,
   -1,  278,   -1,   -1,   -1,   -1,  283,   -1,  285,   -1,
   -1,   -1,  289,   -1,  291,  292,  257,  294,  350,  260,
  261,   -1,  263,   -1,  265,   -1,   -1,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  276,   -1,  278,   -1,   -1,
   -1,  282,  283,   -1,  285,   -1,  257,   -1,  289,  260,
  261,  292,  263,  294,  265,   -1,   -1,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  276,   -1,  278,   -1,   -1,
   -1,   -1,  283,  350,  285,   -1,  257,  288,  289,  260,
  261,  292,  263,  294,  265,   -1,   -1,   -1,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  276,   -1,  278,   -1,   -1,
   -1,  282,  283,   -1,  285,   -1,   -1,   -1,  289,  350,
   -1,  292,  257,  294,   -1,  260,  261,   -1,  263,   -1,
  265,   -1,   -1,   -1,   -1,  270,  260,  261,  262,  263,
  264,  276,   -1,  278,   -1,   -1,   -1,   -1,  283,  350,
  285,   -1,   -1,   -1,  289,   -1,   -1,  292,   -1,  294,
  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,   -1,
   -1,  295,   -1,   -1,   -1,  299,   -1,   -1,   -1,  350,
   -1,  305,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  260,  261,  262,  263,  264,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,   -1,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  350,   -1,  286,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,  262,
  263,  264,   -1,   -1,   -1,   -1,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  279,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  260,  261,  262,  263,  264,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  314,  287,  260,  261,  262,  263,  264,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
  260,  261,  262,  263,  264,   -1,   -1,   -1,   -1,   -1,
  297,  260,  261,  262,  263,  264,   -1,   -1,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,   -1,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,
};
}
final static short YYFINAL=23;
final static short YYMAXTOKEN=355;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"NewLine","WhiteSpace","Not","And","Or","Mod","Xor","Power",
"Type","Of","Struct","Array","EndStruct","Function","VarInput","VarOutput",
"VarInputOutput","EndVar","EndType","Return","EndFunction","If","Then","Else",
"ElseIf","EndIf","Case","EndCase","For","To","By","EndFor","While","Do",
"EndWhile","Repeat","Until","Exit","Comma","Colon","SemiColon","OParen",
"CParen","OBracket","CBracket","OBrace","CBrace","Point","Plus","Minus",
"Asterisk","FSlash","Equal","NotEqual","LessThan","LessThanEqualTo",
"GreaterThan","GreaterThanEqualTo","Assign","Range","Error","NumSeparator",
"DirectRep","Action","EndAction","At","Constant","En","Eno","FEdge",
"InitialStep","EndStep","Program","With","EndProgram","REdge","ReadOnly",
"ReadWrite","Resource","EndResource","Retain","Step","Task","Transition",
"EndTransition","From","VarExternal","VarAccess","VarGlobal","BooleanLiteral",
"IntegerLiteral","LongLiteral","FloatLiteral","Identifier",
"UnclosedStringLiteral","CommentText","StringLiteral","CharLiteral","UNARY",
};
final static String yyrule[] = {
"$accept : ProgramSource",
"Declaration : Identifier Identifier",
"Declaration : Identifier Identifier Assign Expression",
"Declaration : Identifier AssignFunction",
"AssignmentStatement : AssignExpression",
"AssignmentStatement : AssignArray",
"AssignmentStatement : AssignFunction",
"AssignExpression : Identifier Assign Expression",
"AssignArray : Identifier Assign AssignArrayElements",
"AssignArrayElements : AssignArrayElement",
"AssignArrayElements : AssignArrayElements Comma AssignArrayElement",
"AssignArrayElement : IntegerLiteral OParen IntegerLiteral CParen",
"AssignFunction : Identifier Assign FBInvocation",
"TypeDefinition : Type Identifier Colon NewLine TypeBlock EndType",
"TypeBlock : StructType",
"TypeBlock : EnumType",
"TypeBlock : SubrangeType",
"TypeBlock : ArrayType",
"StructType : Struct NewLine StructElements EndStruct SemiColon NewLine",
"StructElements : StructElement",
"StructElements : StructElements StructElement",
"StructElement : Identifier Colon Identifier SemiColon NewLine",
"EnumType : OParen EnumList CParen SemiColon NewLine",
"EnumList : Identifier",
"EnumList : EnumList Comma Identifier",
"SubrangeType : Identifier OParen number Range number CParen SemiColon NewLine",
"ArrayType : Array OBracket ArrayElementList CBracket Of Identifier SemiColon NewLine",
"ArrayElementList : Subrange",
"ArrayElementList : ArrayElementList Comma Subrange",
"SubprogramControlStatement : FBInvocation",
"SubprogramControlStatement : Return",
"FBInvocation : Identifier OParen FBInputs CParen",
"FBInvocation : And OParen FBInputs CParen",
"FBInvocation : Or OParen FBInputs CParen",
"FBInvocation : Xor OParen FBInputs CParen",
"FBInputs : FBInputAssignment",
"FBInputs : FBInputs Comma FBInputAssignment",
"FBInputAssignment : Expression",
"FBInputAssignment : Identifier Assign Expression",
"FunctionDefinition : Function Identifier Colon Identifier NewLine FunctionBlock EndFunction",
"FunctionBlock : FunctionHeader StatementList",
"FunctionHeader : VarInputs",
"FunctionHeader : VarOutputs",
"FunctionHeader : VarInOuts",
"FunctionHeader : FunctionHeader NewLine VarInOuts",
"FunctionHeader : FunctionHeader NewLine VarInputs",
"FunctionHeader : FunctionHeader NewLine VarOutputs",
"VarInputs : VarInput NewLine VarList NewLine EndVar",
"VarOutputs : VarOutput NewLine VarList NewLine EndVar",
"VarInOuts : VarInputOutput NewLine VarList NewLine EndVar",
"VarList : Vars Colon Identifier SemiColon",
"VarList : VarList NewLine VarList",
"Vars : Identifier",
"Vars : Vars Comma Vars",
"FlowStatement : IfStatement",
"FlowStatement : CaseStatement",
"IfStatement : If Expression Then StatementList EndIf",
"IfStatement : If Expression Then StatementList Else StatementList EndIf",
"IfStatement : If Expression Then StatementList ElseIf Expression Then StatementList EndIf",
"IfStatement : If Expression Then StatementList ElseIf Expression Then StatementList Else StatementList EndIf",
"CaseStatement : Case Expression Of NewLine CaseElements CaseElseStatement EndCase",
"CaseElements : CaseElement",
"CaseElements : CaseElements CaseElement",
"CaseElseStatement : NewLine",
"CaseElseStatement : Else StatementList",
"CaseElement : CaseList Colon StatementList",
"CaseList : CaseListElement",
"CaseList : CaseList Comma CaseListElement",
"CaseListElement : Subrange",
"CaseListElement : IntegerLiteral",
"IterationStatement : ForStatement",
"IterationStatement : WhileStatement",
"IterationStatement : RepeatStatement",
"IterationStatement : Exit",
"ForStatement : For Identifier Assign ForList Do StatementList EndFor",
"ForList : Expression To Expression",
"ForList : Expression To Expression By Expression",
"WhileStatement : While Expression Do StatementList EndWhile",
"RepeatStatement : Repeat StatementList Until Expression",
"Statement : NewLine",
"Statement : Declaration SemiColon",
"Statement : TypeDefinition",
"Statement : FunctionDefinition",
"Statement : AssignmentStatement SemiColon",
"Statement : SubprogramControlStatement SemiColon",
"Statement : FlowStatement SemiColon",
"Statement : IterationStatement SemiColon",
"ProgramSource : StatementList",
"StatementList : CommentText",
"StatementList : Statement",
"StatementList : Statement CommentText",
"StatementList : StatementList Statement",
"StatementList : StatementList Statement CommentText",
"StatementList : Expression",
"Subrange : number Range number",
"number : IntegerLiteral",
"number : LongLiteral",
"number : FloatLiteral",
"Expression : BooleanLiteral",
"Expression : Identifier",
"Expression : number",
"Expression : Expression And Expression",
"Expression : Expression Plus Expression",
"Expression : Expression Minus Expression",
"Expression : Expression Asterisk Expression",
"Expression : Expression FSlash Expression",
"Expression : Expression Mod Expression",
"Expression : Expression Power Expression",
"Expression : Expression Or Expression",
"Expression : Expression Xor Expression",
"Expression : Expression Equal Expression",
"Expression : Expression NotEqual Expression",
"Expression : Expression LessThan Expression",
"Expression : Expression LessThanEqualTo Expression",
"Expression : Expression GreaterThan Expression",
"Expression : Expression GreaterThanEqualTo Expression",
"Expression : Minus Expression",
"Expression : Not Expression",
"Expression : OParen Expression CParen",
};

//#line 372 "st.y"
  
  private int lineNo = 0;
  private STLex lexer;
  private ArrayList<ParseError> errors = new ArrayList<ParseError>();
  private Hashtable<String, String> arrayTypes = new Hashtable<String, String>();
  private Hashtable<String, String> arrayInstantiates = new Hashtable<String, String>();
  private StringBuilder source = new StringBuilder();
  private boolean addArrayDef;
  private String arrayDefType;
  private String arrayDefInstantiate;

  private int yylex () {
    int yyl_return = -1;
    try {
      yylval = new STtoJavaVal(0);
      yyl_return = lexer.yylex();
    }
    catch (IOException e) {
      System.err.println("IO error :"+e);
    }
    return yyl_return;
  }
  
  private String postProcess(String code){  
    // Replace all array instantations with valid Java
	for(String s : arrayInstantiates.keySet()){
		int index = 0;
		while((index = code.indexOf("new " + s + "()")) > 0){
			String first = code.substring(0, index);
			String second = code.substring(index + ("new " + s + "()").length());
			code = first + "new " + arrayInstantiates.get(s) + second;
		}
	}

	// Replace all array types
	for(String s : arrayTypes.keySet()){
		int index = 0;
		while((index = code.indexOf(s)) > 0){
			String first = code.substring(0, index);
			String second = code.substring(index + s.length());
			code = first + arrayTypes.get(s) + second;
		}
		code.replaceAll(s, arrayTypes.get(s));
		System.out.println(s + " > " + arrayTypes.get(s));
	}
	
	return code;
  }
  
  /**
   * Adds an error to the result.
   * 
   */
  public void addError(int line, String message, boolean critical){
    try{
	  errors.add(new ParseError(line, message, critical));
	} catch (Exception e) { /**/ }
  }

  /**
   * Returns the Java source.
   * 
   */
  public String getSource(){
    return source.toString();
  }

  /**
   * Returns a list of errors encountered.
   * 
   */
  public ArrayList<ParseError> getErrors(){
    return errors;
  }
  
  /**
   * Gets the parser result.
   * 
   */
  public ParseResult getResult(){
    return new ParseResult(getSource(), getErrors());
  }

  /**
   * Internal, prints an error message.
   * 
   */
  public void yyerror (String error) {
    //System.err.println ("Error: " + error);
    addError(getLine(), error, true);
  }
  
  /**
   * Returns the current line being parsed.
   * 
   */
  public int getLine(){
	return lineNo;
  }

  private String opFuntion(String operator, String arguments){
    // In ST a boolean operator such as AND or OR can be used as a function.
	// This method inserts an operator between a list of arguments to produce
	// the same effect in Java.
    //System.out.println("  OPString: " + operator + " + " + arguments);
    String[] args = arguments.split(",");
    String result = "";
    for(int i = 0; i < args.length; i++){
      if(i > 0) result += " " + operator + " ";
      result += args[i];
    }
    return result;
  }
  
  private String varList(String type, String varNames){
    // Splits a list of variables and inserts a type identifier between them.
    //System.out.println("  VarList: " + type + " + " + varNames);
    String[] vars = varNames.split(",");
    String result = "";
    for(int i = 0; i < vars.length; i++){
      if(i > 0) result += ", ";
      result += type + " " + vars[i].trim();
    }
    return result;
  }
  
//  public static ParseResult parse(Reader r){
//    STtoJava parser = new STtoJava(r);
//    if(parser.yyparse() != 0)
//		parser.addError(parser.getLine(), "Syntax error.", true);
//    return parser.getResult();
//  }
  
  /**
   * Parses a string of Structured Text source code and attempts to translate it into Java.
   * @param r
   */
  public ParseResult parse(Reader r){
  	lexer = new STLex(r, this);
  	yyparse();
    return getResult();
  }
  
  public String getTargetLanguage(){
  	return "Java";
  }
  
  public String getSourceLanguage(){
  	return "ST";
  }
  
  public static void main(String args[]) throws IOException {
  
    STtoJava yyparser;
    if ( args.length > 0 ) {
      // parse a file
      yyparser = new STtoJava();
	  ParseResult r = yyparser.parse(new FileReader(args[0]));
	  
	  System.out.println("\nSource:\n" + yyparser.getSource());
    }
    else {
      yyparser = new STtoJava();
	  ParseResult r = yyparser.parse(new FileReader(
			  "./org/oooneida/wb/translate/Test.st".replace('/', 
					  File.separatorChar)));
	  
	  if(r.hasErrors()){
	  	for(int i = 0; i < r.getErrors().size(); i++){
	  		System.err.println(r.getErrors().get(i));
	  	}
	  }
	  
	  System.out.println("\nSource:\n" + yyparser.getSource());
    }
  }
//#line 1120 "STtoJava.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  val_push(yylval);     //save empty value
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 1:
//#line 43 "st.y"
{ yyval.sval = val_peek(1).sval + " " + val_peek(0).sval + " = new " + val_peek(1).sval + "();"; }
break;
case 2:
//#line 44 "st.y"
{ yyval.sval = val_peek(3).sval + " " + val_peek(2).sval + " = new " + val_peek(3).sval + "(" + val_peek(0).sval + ");"; }
break;
case 3:
//#line 45 "st.y"
{ yyval.sval = val_peek(1).sval + " " + val_peek(0).sval + ";"; }
break;
case 4:
//#line 48 "st.y"
{ yyval.sval = val_peek(0).sval + ";"; }
break;
case 5:
//#line 49 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 6:
//#line 50 "st.y"
{ yyval.sval = val_peek(0).sval + ";"; }
break;
case 7:
//#line 53 "st.y"
{ yyval.sval = val_peek(2).sval + ".value = " + val_peek(0).sval; }
break;
case 8:
//#line 56 "st.y"
{ 
														String result = "";
														String[] elems = val_peek(0).sval.split(",");
														int totalElements = 0;
														for(int i = 0; i < elems.length; i++){
															String strElemCount = elems[i].substring(0, elems[i].indexOf('('));
															String strElemValue = elems[i].substring(elems[i].indexOf('('));
															strElemValue = strElemValue.substring(1, strElemValue.length() - 1);
															/*System.out.println("\nArray strElemCount: " + strElemCount);*/
															/*System.out.println("\nArray strElemValue: " + strElemValue);*/
															
															int count = Integer.parseInt(strElemCount.trim());
															int lt = totalElements + count;
															
															if(i > 0) result += "\n";
															
															result += "for(int i = " + totalElements + "; i < " + lt + 
															 "; i++){ " + val_peek(2).sval + "[i] = " + strElemValue + "; }";
															
															totalElements += count;
														}
														
														/*System.out.println("\nArray result: " + result);*/
														
														/*$$ = $1 + " = " + $3; */
														yyval.sval = result; 
													}
break;
case 9:
//#line 84 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 10:
//#line 85 "st.y"
{ yyval.sval = val_peek(2).sval + ", " + val_peek(0).sval; }
break;
case 11:
//#line 88 "st.y"
{ yyval.sval = val_peek(3).sval + "(" + val_peek(1).sval + ")"; }
break;
case 12:
//#line 91 "st.y"
{ yyval.sval = val_peek(2).sval + " = " + val_peek(0).sval; }
break;
case 13:
//#line 95 "st.y"
{ 
												yyval.sval = val_peek(1).sval.replace("###", val_peek(4).sval); 
												
												if(addArrayDef){
													arrayTypes.put(val_peek(4).sval, arrayDefType);
													arrayInstantiates.put(val_peek(4).sval, arrayDefInstantiate);
													addArrayDef = false;
												}
											}
break;
case 14:
//#line 106 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 15:
//#line 107 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 16:
//#line 108 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 17:
//#line 109 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 18:
//#line 112 "st.y"
{ yyval.sval = "class ### {\n" + val_peek(3).sval + "\n}"; }
break;
case 19:
//#line 115 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 20:
//#line 116 "st.y"
{ yyval.sval = val_peek(1).sval + val_peek(0).sval; }
break;
case 21:
//#line 119 "st.y"
{ yyval.sval = "public " + val_peek(2).sval + " " + val_peek(4).sval + " = new " + val_peek(2).sval + "();\n"; }
break;
case 22:
//#line 122 "st.y"
{ yyval.sval = "enum ### { " + val_peek(3).sval + " }"; }
break;
case 23:
//#line 125 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 24:
//#line 126 "st.y"
{ yyval.sval = val_peek(2).sval + ", " + val_peek(0).sval; }
break;
case 25:
//#line 131 "st.y"
{ 
					System.err.println("(" + lineNo + ") Subrange types not implemented yet."); 
					addError(lineNo, "Subrange types not implemented.", true); 
					yyval.sval = "/* Subrange types not implemented yet.\nTYPE ### :\n" + val_peek(7).sval + "(" + val_peek(5).sval + ".." + val_peek(3).sval + ");\nEND_TYPE\n*/"; 
				}
break;
case 26:
//#line 139 "st.y"
{  
					String type = val_peek(2).sval;
					String instantiate = type;
					String[] dims = val_peek(5).sval.split(",");
					for(int i = 0; i < dims.length; i++){
						String size = dims[i].substring(dims[i].lastIndexOf('.'));
						size = size.substring(1, size.length());
						type += "[]";
						instantiate += "[" + size + "]";
					}
					
					arrayDefInstantiate = instantiate;
					arrayDefType = type;
					addArrayDef = true;
					
					System.out.println("(" + lineNo + ") Array types not implemented, substituting java array " + type);
					addError(lineNo, "### = " + type, false);
					yyval.sval = "";
					/*System.err.println("(" + lineNo + ") Array types not implemented yet.");*/
					/*addError(lineNo, "Array types not implemented.", true); */
					/*$$ = "/* Array types not implemented yet.\nTYPE ### :\nARRAY[" + $3 + "] OF " + $6 + ";\nEND_TYPE\n* /"; */
				}
break;
case 27:
//#line 163 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 28:
//#line 164 "st.y"
{ yyval.sval = val_peek(2).sval + ", " + val_peek(0).sval; }
break;
case 29:
//#line 167 "st.y"
{ yyval.sval = val_peek(0).sval + ";"; }
break;
case 30:
//#line 168 "st.y"
{ yyval.sval = "return;"; }
break;
case 31:
//#line 171 "st.y"
{ yyval.sval = val_peek(3).sval + "(" + val_peek(1).sval + ")"; }
break;
case 32:
//#line 172 "st.y"
{ yyval.sval = opFuntion("&&", val_peek(1).sval); }
break;
case 33:
//#line 173 "st.y"
{ yyval.sval = opFuntion("||", val_peek(1).sval); }
break;
case 34:
//#line 174 "st.y"
{ yyval.sval = opFuntion("^", val_peek(1).sval); }
break;
case 35:
//#line 177 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 36:
//#line 178 "st.y"
{ yyval.sval = val_peek(2).sval + ", " + val_peek(0).sval; }
break;
case 37:
//#line 181 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 38:
//#line 183 "st.y"
{ 
												System.err.println("(" + lineNo + ") Named parameters are not supported.");
												addError(lineNo, "Named parameters are not supported.", true); 
												yyval.sval = "/* Named parameters are not supported: " + val_peek(2).sval + " := " + val_peek(0).sval + "*/"; 
											}
break;
case 39:
//#line 191 "st.y"
{
												String[] parts = val_peek(1).sval.split("###");
												String header = parts[0].trim();
												String block = parts[1].trim();
												
												yyval.sval = val_peek(3).sval + " " + val_peek(5).sval + "(" + header + "){\n" + val_peek(3).sval + " " + val_peek(5).sval + " = new " + val_peek(3).sval + "();\n" + 
													block + "\nreturn " + val_peek(5).sval + ";\n}"; 
											}
break;
case 40:
//#line 201 "st.y"
{ 
											  addError(lineNo, "Functions cannot be declared inside algorithms.", false);
											  yyval.sval = val_peek(1).sval + "###" + val_peek(0).sval; 
											}
break;
case 41:
//#line 207 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 42:
//#line 208 "st.y"
{ 
												System.out.println("(" + lineNo + ") Output vars not supported."); 
												addError(lineNo, "Output vars not supported.", true);
												yyval.sval = "";
											}
break;
case 43:
//#line 213 "st.y"
{ 
												System.out.println("(" + lineNo + ") InputOutput vars not supported."); 
												addError(lineNo, "InputOutput vars not supported.", true);
												yyval.sval = ""; 
											}
break;
case 44:
//#line 218 "st.y"
{ yyval.sval = val_peek(2).sval + "\n" + val_peek(0).sval; }
break;
case 45:
//#line 219 "st.y"
{ yyval.sval = val_peek(2).sval + "\n" + val_peek(0).sval; }
break;
case 46:
//#line 220 "st.y"
{ yyval.sval = val_peek(2).sval + "\n" + val_peek(0).sval; }
break;
case 47:
//#line 223 "st.y"
{ yyval.sval = val_peek(2).sval; }
break;
case 48:
//#line 226 "st.y"
{ yyval.sval = ""; }
break;
case 49:
//#line 228 "st.y"
{ yyval.sval = ""; }
break;
case 50:
//#line 231 "st.y"
{ yyval.sval = varList(val_peek(1).sval, val_peek(3).sval); }
break;
case 51:
//#line 232 "st.y"
{ yyval.sval = val_peek(2).sval + "\n" + val_peek(0).sval; }
break;
case 52:
//#line 235 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 53:
//#line 236 "st.y"
{ yyval.sval = val_peek(2).sval + ", " + val_peek(0).sval; }
break;
case 54:
//#line 239 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 55:
//#line 240 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 56:
//#line 245 "st.y"
{ yyval.sval = "if (" + val_peek(3).sval + "){" +val_peek(1).sval + "}"; }
break;
case 57:
//#line 247 "st.y"
{ yyval.sval = "if (" + val_peek(5).sval + "){" + val_peek(3).sval + "} else {" + val_peek(1).sval + "}"; }
break;
case 58:
//#line 249 "st.y"
{ yyval.sval = "if (" + val_peek(7).sval + "){" + val_peek(5).sval + "} else if(" + val_peek(3).sval + ") {" + val_peek(1).sval + "}"; }
break;
case 59:
//#line 251 "st.y"
{ yyval.sval = "if (" + val_peek(9).sval + "){" + val_peek(7).sval + "} else if(" + val_peek(5).sval + ") {" + val_peek(3).sval + "} else {" + val_peek(1).sval + "}"; }
break;
case 60:
//#line 255 "st.y"
{ yyval.sval = "switch (" + val_peek(5).sval + "){" + val_peek(2).sval + val_peek(1).sval + "}"; }
break;
case 61:
//#line 258 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 62:
//#line 259 "st.y"
{ yyval.sval = val_peek(1).sval + val_peek(0).sval; }
break;
case 63:
//#line 262 "st.y"
{ yyval.sval = ""; }
break;
case 64:
//#line 263 "st.y"
{ yyval.sval = "default: " + val_peek(0).sval; }
break;
case 65:
//#line 266 "st.y"
{ String block = val_peek(0).sval; if(block.length() > 0) block += "break;\n"; yyval.sval = val_peek(2).sval + block; }
break;
case 66:
//#line 269 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 67:
//#line 270 "st.y"
{ yyval.sval = "\n" + val_peek(0).sval; }
break;
case 68:
//#line 273 "st.y"
{ 
												/* Substitute list of cases*/
												String[] parts = val_peek(0).sval.split("\\.\\.");
												int start = Integer.parseInt(parts[0]);
												int end = Integer.parseInt(parts[1]);
												String result = "";
												for(int i = start; i < end - start; i++)
													result += "case " + i + ":\n";
												yyval.sval = result;
											}
break;
case 69:
//#line 283 "st.y"
{ yyval.sval = "case " + val_peek(0).sval + ": "; }
break;
case 70:
//#line 286 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 71:
//#line 287 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 72:
//#line 288 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 73:
//#line 289 "st.y"
{ yyval.sval = "break"; }
break;
case 74:
//#line 293 "st.y"
{ String temp = val_peek(3).sval.replace("###", val_peek(5).sval + ".value"); yyval.sval = "for(" + val_peek(5).sval + ".value = " + temp + "){" + val_peek(1).sval + "}"; }
break;
case 75:
//#line 296 "st.y"
{ yyval.sval = val_peek(2).sval + "; ### <= " + val_peek(0).sval + "; ###++"; }
break;
case 76:
//#line 297 "st.y"
{ yyval.sval = val_peek(4).sval + "; ### != " + val_peek(2).sval + "; ### = ###" + (val_peek(0).sval.charAt(0) == '-' ? val_peek(0).sval : "+" + val_peek(0).sval); }
break;
case 77:
//#line 301 "st.y"
{ yyval.sval = "while(" + val_peek(3).sval + "){" + val_peek(1).sval + "}"; }
break;
case 78:
//#line 305 "st.y"
{ 
												System.err.println("(" + lineNo + ") Java does not support do-util.");
												addError(lineNo, "Java does not support do-until.", false);
												yyval.sval = "/* Warning: Java does not support do-until, please ensure the following block is correct: */\n" + 
												"do {" + val_peek(2).sval + "} while(!(" + val_peek(0).sval + "))" + 
												"\n/* Original expression: " + val_peek(0).sval + " */"; 
											}
break;
case 79:
//#line 314 "st.y"
{ lineNo++; yyval.sval = "\n"; }
break;
case 80:
//#line 315 "st.y"
{ yyval.sval = val_peek(1).sval; }
break;
case 81:
//#line 316 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 82:
//#line 317 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 83:
//#line 318 "st.y"
{ yyval.sval = val_peek(1).sval; }
break;
case 84:
//#line 319 "st.y"
{ yyval.sval = val_peek(1).sval; }
break;
case 85:
//#line 320 "st.y"
{ yyval.sval = val_peek(1).sval; }
break;
case 86:
//#line 321 "st.y"
{ yyval.sval = val_peek(1).sval; }
break;
case 87:
//#line 325 "st.y"
{
				String code = postProcess(val_peek(0).sval);
				source.append(code); 
			}
break;
case 88:
//#line 331 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 89:
//#line 332 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 90:
//#line 333 "st.y"
{ yyval.sval = val_peek(1).sval; }
break;
case 91:
//#line 334 "st.y"
{ yyval.sval = val_peek(1).sval + val_peek(0).sval; }
break;
case 92:
//#line 335 "st.y"
{ yyval.sval = val_peek(2).sval + val_peek(1).sval; }
break;
case 93:
//#line 336 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 94:
//#line 339 "st.y"
{ yyval.sval = val_peek(2).sval + ".." + val_peek(0).sval; }
break;
case 95:
//#line 342 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 96:
//#line 343 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 97:
//#line 344 "st.y"
{ if(val_peek(0).sval.trim().charAt(0) == '.') yyval.sval = "0" + val_peek(0).sval.trim(); else yyval.sval = val_peek(0).sval; }
break;
case 98:
//#line 347 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 99:
//#line 348 "st.y"
{ yyval.sval = val_peek(0).sval + ".value"; }
break;
case 100:
//#line 349 "st.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 101:
//#line 350 "st.y"
{ yyval.sval = val_peek(2).sval + " && " + val_peek(0).sval; }
break;
case 102:
//#line 351 "st.y"
{ yyval.sval = val_peek(2).sval + " + " + val_peek(0).sval; }
break;
case 103:
//#line 352 "st.y"
{ yyval.sval = val_peek(2).sval + " - " + val_peek(0).sval; }
break;
case 104:
//#line 353 "st.y"
{ yyval.sval = val_peek(2).sval + " * " + val_peek(0).sval; }
break;
case 105:
//#line 354 "st.y"
{ yyval.sval = val_peek(2).sval + " / " + val_peek(0).sval; }
break;
case 106:
//#line 355 "st.y"
{ yyval.sval = val_peek(2).sval + " % " + val_peek(0).sval; }
break;
case 107:
//#line 356 "st.y"
{ yyval.sval = "Math.pow(" + val_peek(2).sval + ", " + val_peek(0).sval + ")"; }
break;
case 108:
//#line 357 "st.y"
{ yyval.sval = val_peek(2).sval + " || " + val_peek(0).sval; }
break;
case 109:
//#line 358 "st.y"
{ yyval.sval = val_peek(2).sval + " ^ " + val_peek(0).sval; }
break;
case 110:
//#line 359 "st.y"
{ yyval.sval = val_peek(2).sval + " == " + val_peek(0).sval; }
break;
case 111:
//#line 360 "st.y"
{ yyval.sval = val_peek(2).sval + " != " + val_peek(0).sval; }
break;
case 112:
//#line 361 "st.y"
{ yyval.sval = val_peek(2).sval + " < " + val_peek(0).sval; }
break;
case 113:
//#line 362 "st.y"
{ yyval.sval = val_peek(2).sval + " <= " + val_peek(0).sval; }
break;
case 114:
//#line 363 "st.y"
{ yyval.sval = val_peek(2).sval + " > " + val_peek(0).sval; }
break;
case 115:
//#line 364 "st.y"
{ yyval.sval = val_peek(2).sval + " >= " + val_peek(0).sval; }
break;
case 116:
//#line 365 "st.y"
{ yyval.sval = "-" + val_peek(0).sval; }
break;
case 117:
//#line 366 "st.y"
{ yyval.sval = "!" + val_peek(0).sval; }
break;
case 118:
//#line 367 "st.y"
{ yyval.sval = "(" + val_peek(1).sval + ")"; }
break;
//#line 1839 "STtoJava.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
/**
 * A default run method, used for operating this parser
 * object in the background.  It is intended for extending Thread
 * or implementing Runnable.  Turn off with -Jnorun .
 */
public void run()
{
  yyparse();
}
//## end of method run() ########################################



//## Constructors ###############################################
/**
 * Default constructor.  Turn off with -Jnoconstruct .

 */
public STtoJava()
{
  //nothing to do
}


/**
 * Create a parser, setting the debug to true or false.
 * @param debugMe true for debugging, false for no debug.
 */
public STtoJava(boolean debugMe)
{
  yydebug=debugMe;
}
//###############################################################



}
//################### END OF CLASS ##############################
