//Copyright (c) 2007 University of Auckland
//Contributed to the FBench extension of the OOONEIDA Workbench project under the Common Public License

package org.oooneida.wb.translate;

import java.util.Hashtable;

public class TranslatorSource {
	protected Hashtable<String, Hashtable<String, Class>> map;
	
	public TranslatorSource(){
		map = new Hashtable<String, Hashtable<String, Class>>();
	}
	
	public Translator getTranslator(String fromLanguage, String toLanguage){
		
		String from = fromLanguage.toLowerCase();
		String to = toLanguage.toLowerCase();
				
		if(map.containsKey(from)){
			Hashtable<String, Class> targets = map.get(from);
			if(targets.containsKey(to)){
				return Spawn(targets.get(to));
			}
		}
		
		return null;
	}
	
	private Translator Spawn(Class tClass){
		try {
			return (Translator)tClass.newInstance();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public void addTranslator(Class translatorClass, String source, String target){
		Class[] interfaces = translatorClass.getInterfaces();
		for(Class test : interfaces){
			if(!test.getName().equals(Translator.class.getName())){
				System.err.println("Class " + translatorClass.getName() + 
						" does not implement Translator.");
				return;
			}
		}

		if(!map.containsKey(source.toLowerCase())){
			map.put(source.toLowerCase(), new Hashtable<String, Class>());
		}
		map.get(source.toLowerCase())
			.put(target.toLowerCase(), translatorClass);
	}
}
