//Copyright (c)2005 Holobloc Inc.
//Contributed to the OOONEIDA FBench project under the Common Public License.
package org.oooneida.wb.tree;

import java.util.Vector;

import javax.swing.Icon;

import org.oooneida.wb.IconFactory;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * A DOM tree node for a Function Block type.
 * 
 * @author JHC
 * @version 20051008/JHC
 */
public class FBType extends DOMTreeNode {
    public Icon getIcon() {
        return IconFactory.getIcon("fb");
    }

    public boolean getAllowsChildren() {
        return true;
    }

    public Vector getChildren() {
        Vector ans = super.getChildren();
        NodeList nodes = getElement().getElementsByTagName("BasicFB");
        Vector<DOMTreeNode> algorithms = new Vector<DOMTreeNode>();
        boolean isAlgorithmAdded = false;
        if (nodes.getLength() > 0) {
            Element bfb = (Element) nodes.item(0);
            nodes = bfb.getChildNodes();
            
            for (int i = 0; i < nodes.getLength(); i++) {
                DOMTreeNode node = DOMTreeNode.treeNodeForElement((Element) nodes
                        .item(i));
                try{
            	/**
            	 * Restructuring the FBType tree
            	 * 	All Algorithm elements are categorized under AlgorithmList
            	 */
                if(node.getElement().getNodeName().equals("Algorithm")){
                	if(!isAlgorithmAdded){
                    	Element algListElem = getElement().getOwnerDocument().createElement("AlgorithmList");
                    	DOMTreeNode algorithmList = treeNodeForElement(algListElem);
                    	((AlgorithmList) algorithmList).setAlgorithm(algorithms);
                    	ans.add(algorithmList);
                    	isAlgorithmAdded = true;
                	}
                	algorithms.add(node);
                }
                else if (node != null)
                    ans.add(node);
                }
                catch(NullPointerException e){}
            }
        }
        return ans;
    }
    
    
}
